<?php

error_reporting(0);

define('DB_CACHE', 'false');
define('SESSION_CHECK_SSL_SESSION_ID', 0);
define('SUPPRESS_REDIRECT', 1);
define('SESSION_CHECK_USER_AGENT', 0);
define('SESSION_CHECK_IP_ADDRESS', 0);
define('SESSION_FORCE_COOKIE_USE', 0);
define('SUPPRESS_UPLOAD_CHECKS', 1);
define('SUPPRESS_DIE', 1);
define('TABLE_CONFIGURATION', 'configuration');
define('_VALID_XTC', true);
define('DEFAULT_CUSTOMERS_STATUS_ID_GUEST', '0');

$USE_DEBUG = false;

$USE_DEBUG = $USE_DEBUG && (realpath(dirname(__FILE__)."/../../../../test/logs.txt") != FALSE);
$DEBUG_FILENAME = "";
if ($USE_DEBUG)
	$DEBUG_FILENAME = realpath(dirname(__FILE__)."/../../../../test/logs.txt");

//set_time_limit(480);

if (file_exists(dirname(__FILE__) . '/UserFunctions.php')) {
    require_once 'UserFunctions.php';
}

$old_dir = dirname(__FILE__);
chdir('../..');
require('includes/application_top.php');
chdir($old_dir);

class gx2_v21Controller implements RestController {

	private function ClearFile()
	{
		global $USE_DEBUG;
		global $DEBUG_FILENAME;
	
		if ($USE_DEBUG)
		{
			$datei = fopen ($DEBUG_FILENAME, "w");
			fwrite ($datei, "Log Text :\n\n");
			fclose ($datei);
		}
	}

	private function Write($zeile)
	{
		global $USE_DEBUG;
		global $DEBUG_FILENAME;
	
		if ($USE_DEBUG)
		{
			$datei = fopen ($DEBUG_FILENAME, "a");
			fwrite ($datei, $zeile);
			fclose ($datei);
		}
	}

	private function WriteLine($zeile)
	{
		global $USE_DEBUG;
		global $DEBUG_FILENAME;

		if ($USE_DEBUG)
		{	
			$datei = fopen ($DEBUG_FILENAME, "a");
			fwrite ($datei, $zeile."\n");
			fclose ($datei);
		}
	}

    //***********************************
    //WICHTIG Versionsnummer immer angeben:
    private $version = "2.0.4.4 rev1";

    //***********************************

    public function execute(RestServer $rest) {
        //*************HOOK ANFANG************
        if (HOOK_ACTIVE) {
            $hook = "gx2Controller_beforeExecuteReturn.php";
            if (file_exists("hooks/" . $hook)) {
                if (GX2CONTROLLER_BEFOREEXECUTERETURN == true) {
                    return require("hooks/" . $hook);
                } else {
                    require("hooks/" . $hook);
                }
            }
        }
        //*************HOOK ENDE***************
        $rest->getResponse()->setResponse("REST GX21 is running...");
        return $rest;
    }

    function connectDB(RestServer $rest) {
        $old_dir = dirname(__FILE__);
        chdir('../../..');
        if (file_exists('includes/configure.php')) {
            include('includes/configure.php');
        } else {
            die("no configuration file");
        }

        chdir($old_dir);
		
		if (strpos(DB_SERVER, ':') !== false) {
			$server_array = explode(':', DB_SERVER);
			$server = $server_array[0];
			$socketOrPort = $server_array[1];
			$usePort = is_numeric($socketOrPort);
			if ($usePort)
				$db = new mysqli($server, DB_SERVER_USERNAME, DB_SERVER_PASSWORD, DB_DATABASE, $socketOrPort);
			else 
				$db = new mysqli($server, DB_SERVER_USERNAME, DB_SERVER_PASSWORD, DB_DATABASE, false, $socketOrPort);
		}
		else 
			$db = new mysqli(DB_SERVER, DB_SERVER_USERNAME, DB_SERVER_PASSWORD, DB_DATABASE, false);
		
        //$db = new mysqli(DB_SERVER, DB_SERVER_USERNAME, DB_SERVER_PASSWORD, DB_DATABASE, false);
        if (mysqli_connect_errno()) {
            die("no database connection");
        }

        $db->query("SET NAMES utf8");

        $rest->setParameter("db", $db);
    }

    function closeDB(RestServer $rest) {
        $db = $rest->getParameter("db");
        $db->close();
    }

    function loginShop(RestServer $rest) {
        $rest->setParameter("controller_version", $this->version);
        $rest->setParameter("controller_datum", date("d.m.Y H:i:s", filemtime(__FILE__)));

        $db = $rest->getParameter("db");
        $user = $rest->getParameter("user");
        $password = $rest->getParameter("password");

        $sql = "SELECT customers_password FROM customers where customers_email_address = ? and customers_status = 0";
        $stmt = $db->prepare($sql);
        $stmt->bind_param('s', $user);

        $stmt->execute();
        $stmt->bind_result($pwdb);

        $stmt->fetch();
        $stmt->close();

        if (!$pwdb) {
            return false;
        }
        $pwdb = strtoupper($pwdb);

        if ($pwdb == $password)
            return true;
        else
            return false;
    }

    function createProduct(RestServer $rest) {
		$this->WriteLine (">-- createProduct");
        $view = new XMLView();
        try {
            $xml = $rest->getRequest()->getBody();
            $db = $rest->getParameter("db");
			$this->WriteLine ($xml);
            $xmlDoc = new DomDocument();
            if (!($xmlDoc->loadXML($xml))) {
                $view->init('1', 'Keine XML Daten', '', '', $xml, __FUNCTION__, '');
                return $view;
            }

			$permission_module_activated = false;
			
			$sql = "SELECT COUNT(COLUMN_NAME) AS PERM_MOD_ACTIVE FROM INFORMATION_SCHEMA.Columns WHERE TABLE_SCHEMA='".DB_DATABASE."' AND TABLE_NAME='products' AND COLUMN_NAME LIKE 'group_permission_%'";
			if ( $result = $db->query($sql) )
			{
				while ( $obj = mysqli_fetch_object($result) )
				{
					if ($obj->PERM_MOD_ACTIVE > 0)
						$permission_module_activated = true;
				}
			}
			
            $product = $xmlDoc->getElementsByTagName("product")->item(0);

            //produktid filtern
            foreach ($product->childNodes as $child) {
                if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "products_model") {
                    $id = trim($child->nodeValue);
                    break;
                }
            }
            // Artikel schon vorhanden??
            $sql = "SELECT products_id FROM products WHERE products_model = '" . $db->real_escape_string($id) . "';";
            $products_id = $db->query($sql)->fetch_object()->products_id;


            // Kundengruppen holen
            $sql = "SELECT customers_status_id FROM customers_status group by customers_status_id;";
            $result = $db->query($sql);
            $i = 0;
            while ($obj = $result->fetch_object()) {
                $customers_groups[$i] = $obj->customers_status_id;
                $i++;
            }

            $artikelstatus = '';

            if ($products_id) {
                $vorhanden = true;
                $artikelstatus = 'updated';
            } else {
                $vorhanden = false;
                $artikelstatus = 'new';
            }

			$products_unit_description = "";
			$products_permission_status = "0";

            //Artikeleinträge sammeln
            $querypart = "";
            foreach ($product->childNodes as $child) {
                if ($db->real_escape_string($child->nodeName) == 'products_vpe') {
                    $products_vpe = $db->real_escape_string($child->nodeValue);
                    $querypart .= products_vpe . "='" . $this->GetProductsVPEID($products_vpe, $db) . "',";
                    continue;
                }
                if ($db->real_escape_string($child->nodeName) == 'products_min_order') {
                    $products_min = $db->real_escape_string($child->nodeValue);
                    $querypart .= "gm_min_order = '" . $products_min . "',";
                    continue;
                }
                if ($db->real_escape_string($child->nodeName) == 'products_graduated_qty') {
                    $products_grad = $db->real_escape_string($child->nodeValue);
                    $querypart .= "gm_graduated_qty = '" . $products_grad . "',";
                    continue;
                }
                if ($db->real_escape_string($child->nodeName) == 'products_unit_description') {
                    $products_unit_description = $db->real_escape_string($child->nodeValue);
                    continue;
                }
				if ($db->real_escape_string($child->nodeName) == 'products_price_status') {
					$gm_price_status = $db->real_escape_string($child->nodeValue);
					$querypart .= "gm_price_status = '" . $gm_price_status . "',";
					continue;
				}
				if ($db->real_escape_string($child->nodeName) == 'products_permission_status') {
					$products_permission_status = $db->real_escape_string($child->nodeValue);
					continue;
                }				
				if ($db->real_escape_string($child->nodeName) == 'manufacturers_id') {
                    $manufacturers_id = $db->real_escape_string($child->nodeValue);
                    if (!$manufacturers_id || $manufacturers_id == "")
						$manufacturers_id = "0";
                    $querypart .=  " manufacturers_id ='$manufacturers_id',";
                    continue;
				}              
                $querypart .= $db->real_escape_string($child->nodeName) . "='" . $db->real_escape_string($child->nodeValue) . "',";
            }

            //Artikel für Kundengruppen anzeigen
			if ($permission_module_activated)
			{
				if ($products_permission_status == "0")
				{
					foreach ($customers_groups as $customer_group)
					{
						$querypart .= "group_permission_" . $customer_group . "='1',";
					}
				}
				else
				{
					foreach ($customers_groups as $customer_group)
					{
						$querypart .= "group_permission_" . $customer_group . "='0',";
					}
				}
			}

			      $opt_property =  $xmlDoc->getElementsByTagName("opt_property");

			      foreach ($opt_property as $opt) {
				      foreach ($opt->childNodes as $child) {
					
                              if ($db->real_escape_string($child->nodeName) == 'opt_stock') {
							      $querypart .= "use_properties_combis_quantity = '" . $db->real_escape_string($child->nodeValue) . "',";
							      continue;
						      }
                              if ($db->real_escape_string($child->nodeName) == 'opt_dropdown') {
							      $querypart .= "properties_dropdown_mode = '" . $db->real_escape_string($child->nodeValue) . "',";
							      continue;
						      }	
                              if ($db->real_escape_string($child->nodeName) == 'opt_weight') {
							      $querypart .= "use_properties_combis_weight = '" . $db->real_escape_string($child->nodeValue) . "',";
							      continue;
						      }	
                              if ($db->real_escape_string($child->nodeName) == 'opt_delivery') {
							      $querypart .= "use_properties_combis_shipping_time = '" . $db->real_escape_string($child->nodeValue) . "',";
							      continue;
						      }	
                              if ($db->real_escape_string($child->nodeName) == 'opt_price') {
						 
							      $querypart .= "properties_show_price = '" . $db->real_escape_string($child->nodeValue) . "',";
							      continue;
						      }	
					    }						 
			      }
           
            // das letzte Komma entfernen
            $querypart = substr($querypart, 0, strlen($querypart) - 1);

            // Artikel ändern/anlegen
            if ($vorhanden == true) {
                $query = "UPDATE products SET " . $querypart . " WHERE products_id= '" . $products_id . "';";
            } else {
                $query = "INSERT INTO products SET " . $querypart . ";";
            }

            $queries = $query;

            if ($db->query($query)) {

				//Permissions setzen
				$querypart = "";
				$products_permissions =  $xmlDoc->getElementsByTagName("products_permissions");

			if ($permission_module_activated)
			{
				foreach ($products_permissions as $products_permission)
				{
					foreach ($products_permission->childNodes as $child)
					{
						if ($db->real_escape_string($child->nodeName) == 'permission_customer_group')
						{
							$querypart .= "group_permission_". $db->real_escape_string($child->nodeValue). " = '1',";
							continue;
						}
					}
				}
				
				if (strlen($querypart) > 0)
				{
					$querypart = substr($querypart, 0, strlen($querypart) - 1);
					
					$sql = "UPDATE products SET " . $querypart . " WHERE products_model = '" . $db->real_escape_string($id) . "';";
					$db->query($sql);
					$queries .= $sql;
				}
			}

                //bei Neueintrag products_id holen
                if ($vorhanden == false) {
                    $sql = "SELECT products_id FROM products WHERE products_model = '" . $db->real_escape_string($id) . "';";
                    $products_id = $db->query($sql)->fetch_object()->products_id;
                }

				if ($products_unit_description != NULL && $products_unit_description != "") {
					$dummy = $this->GetUnit($products_unit_description, $products_id, $db);
				}

                //so jetzt die Beschreibungen reinkloppen
                $prodescriptions = $xmlDoc->getElementsByTagName("description");

                $multi_queries = "";
                foreach ($prodescriptions as $prodescription) {

                    $querypart = "";
                    foreach ($prodescription->childNodes as $child) {
                        $childnodeName = $child->nodeName;
                        if ($child->nodeName == "products_image_alt") {
                            $childnodeName = "gm_alt_text";
                        }

                        $querypart .= $db->real_escape_string($childnodeName) . "='" . $db->real_escape_string($child->nodeValue) . "',";
                        if ($child->nodeName == "language_id") {
                            $language_id = trim($db->real_escape_string($child->nodeValue));
                        }
                    }

                    $querypart .= "products_id ='" . $products_id . "'";

                    // Beschreibung schon vorhanden??
                    $sql = "SELECT products_id FROM products_description WHERE products_id = '" . $db->real_escape_string($products_id) . "' AND language_id = " . $db->real_escape_string($language_id) . ";";
                    $products_desc_id = $db->query($sql)->fetch_object()->products_id;

                    if ($products_desc_id) {
                        $query = "UPDATE products_description SET " . $querypart . " WHERE products_id = '" . $products_desc_id . "' AND language_id = '" . $language_id . "';";
                    } else {
                        $query = "INSERT INTO products_description SET " . $querypart . ";";
                    }

                    $multi_queries .= $query;
                }

                $sql = "delete from products_images where products_id = '" . $db->real_escape_string($products_id) . "';";
                $db->query($sql);
                $queries .= $sql;

                $sql = "delete from gm_prd_img_alt where products_id = '" . $db->real_escape_string($products_id) . "';";
                $db->query($sql);
                $queries .= $sql;

                // Zusätzliche Bilder
                $bilder = $xmlDoc->getElementsByTagName("image");
                // $bildernamen = "";
                foreach ($bilder as $bild) {

                    foreach ($bild->childNodes as $child) {
                        if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "image_nr") {
                            $bildnummer = trim($db->real_escape_string($child->nodeValue));
                            continue;
                        }
                        if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "image_name") {
                            $bildname = trim($db->real_escape_string($child->nodeValue));
                            continue;
                        }
                    }
                 

                    $query = "INSERT INTO products_images SET image_name = '" . $bildname . "', image_nr = '" . $bildnummer . "', products_id = '" . $db->real_escape_string($products_id) . "'; ";
                    $db->query($query);
                    $queries .= $query;

                    $sql = "SELECT image_id FROM products_images WHERE products_id = '" . $db->real_escape_string($products_id) . "' AND image_nr = '" . $db->real_escape_string($bildnummer) . "' and image_name = '" . $bildname . "';";
                    $products_image_id = $db->query($sql)->fetch_object()->image_id;

                    if ($products_image_id) {
                        foreach ($bild->childNodes as $child) {
                            if ($child->nodeName == "image_info") {
                                foreach ($child->childNodes as $imageinfochild) {
                                    if ($imageinfochild->nodeType == XML_ELEMENT_NODE && $imageinfochild->nodeName == "language_id") {
                                        $langid = trim($db->real_escape_string($imageinfochild->nodeValue));
                                        continue;
                                    }
                                    if ($imageinfochild->nodeType == XML_ELEMENT_NODE && $imageinfochild->nodeName == "text") {
                                        $alttext = trim($db->real_escape_string($imageinfochild->nodeValue));
                                        continue;
                                    }
                                }

                                $query = "INSERT INTO gm_prd_img_alt set image_id = '" . $db->real_escape_string($products_image_id) . "', products_id = '" . $db->real_escape_string($products_id) . "', language_id = '" . $db->real_escape_string($langid) . "', gm_alt_text = '" . $db->real_escape_string($alttext) . "';";
                                $db->query($query);
                                $queries .= $query;
                            }
                        }
                    }
                }
              
                foreach ($customers_groups as $customer_group) {
                    $multi_queries .= "delete from personal_offers_by_customers_status_" . $customer_group . " where products_id='" . $products_id . "'; ";
                }
                $preislisten = $xmlDoc->getElementsByTagName("pricelist");
                foreach ($preislisten as $preise) {

                    foreach ($preise->childNodes as $child) {
                        if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "customers_group_name") {
                            $customersgroup = $db->real_escape_string(trim($child->nodeValue));
                            continue;
                        }
                        if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "price") {
                            $price = trim($db->real_escape_string($child->nodeValue));
                            continue;
                        }
                        if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "quantity") {
                            $quantity = trim($db->real_escape_string($child->nodeValue));
                            continue;
                        }
                    }

                    $sql = "select customers_status_id from customers_status where customers_status_name = '" . $db->real_escape_string($customersgroup) . "';";
                    $customers_status_id = $db->query($sql)->fetch_object()->customers_status_id;

                    $query = "insert into personal_offers_by_customers_status_" . $customers_status_id . " (products_id, quantity, personal_offer)";
                    $query .= " values ('" . $products_id . "','" . $quantity . "','" . $price . "');";

                    $multi_queries .= $query;
                }

                // Google Kategorie schreiben

                $google = $xmlDoc->getElementsByTagName("google")->item(0);

                if ($google) {
                    foreach ($google->childNodes as $child) {
                        if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "google_category") {
                            $google_category = trim($child->nodeValue);
                            break;
                        }
                    }
                    if ($google_category) {

                        $db->query("Delete from products_google_categories where products_id = '" . $products_id . "' ");
                        $query = "insert into products_google_categories (products_id, google_category) values('" . $products_id . "','" . $google_category . "') ";

                        $db->query($query);
                    }
                }

                //Sonderpreis setzen
                $sonderpreise = $xmlDoc->getElementsByTagName("products_special");
                foreach ($sonderpreise as $sonderpreis) {
                    $toset = "";
                    foreach ($sonderpreis->childNodes as $child) {
                        if ($child->nodeType == XML_ELEMENT_NODE) {

                            $currval = strval(trim($db->real_escape_string($child->nodeValue)));
                            if (strlen($currval) == 0)
                                $currval = 'NULL';
                            else
                                $currval = "'$currval'";

                            if ($child->nodeName == 'id')
                                $products_model = $currval;
                            else
                                $toset .= $db->real_escape_string($child->nodeName) . "=$currval,";
                        }
                    }
                    $toset = substr($toset, 0, strlen($toset) - 1);
                    $toset = "products_id='$products_id'," . $toset;

                    $sql = "SELECT products_id FROM specials  WHERE products_id='" . $db->real_escape_string($products_id) . "';";
                    $products_special_id = $db->query($sql)->fetch_object()->products_id;

                    if ($products_special_id) {
                        $query = "UPDATE specials SET " . $toset . " WHERE products_id='$products_id';";
                    } else {
                        $query = "INSERT INTO specials SET " . $toset . ";";
                    }

                    $multi_queries .= $query;
                }

                $queries .= $multi_queries;
                //Multi Query
                if ($db->multi_query($multi_queries)) {
                    // Flushen, da sonst spätere Queries nicht mehr funktionieren
                    while ($db->next_result()) {
                        ;
                    }


                    // Kategorien
					
					$sql = "DELETE FROM products_to_categories WHERE products_id = ". $db->real_escape_string($products_id);
					$result = $db->query($sql);					
					
                    $products_to_cats = $xmlDoc->getElementsByTagName("ProductToCategory");

					foreach ($products_to_cats As $entry) {
						$tempID = null;
						foreach ($entry->childNodes as $childNode) {
							if ($childNode->nodeType == XML_ELEMENT_NODE && $childNode->nodeName == "categories_id") {
								$categories_id = trim($childNode->nodeValue);
								continue;
							}
						}
						//Check if this combination already exists. If not insert it into the database.
						$sql = "SELECT products_id FROM products_to_categories WHERE products_id = ? AND categories_id = ?";
						$stmt = $db->prepare($sql);
						$stmt->bind_param('ss', $products_id, $categories_id);
						$stmt->execute();
						$stmt->bind_result($tempID);
						$stmt->fetch();
						$stmt->close();
						
						if (!$tempID) {
							$sql = "INSERT INTO products_to_categories (categories_id, products_id) VALUES (?,?)";
						} 
						
						$stmt = $db->prepare($sql);
						$stmt->bind_param('ss', $categories_id, $products_id);
						if ($stmt->execute() == false) {
							$stmt->close();
							$view->init('1', 'Der Artikel konnte keiner Kategorie zugeordnet werden.', '', '', $sql, __FUNCTION__, '');
							return $view;
						}
						$stmt->close();
						
					}

                    //  Einträge in der Features Tabelle aktualisieren

                    $sql = "delete from categories_index WHERE products_id = '" . $db->real_escape_string($products_id) . "';";
                    $result = $db->query($sql);

                    $coo_feature_handler = MainFactory::create_object('CategoriesIndex');
                    $coo_feature_handler->build_categories_index($products_id);

                    // Attribute
                    // erst mal alle alten zuweisungen löschen

                    $sql = "delete from products_attributes where products_id = '" . $db->real_escape_string($products_id) . "';";
                    $result = $db->query($sql);

                    if ($result == false) {
                        $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
                        return $view;
                    }

                    $attribute = $xmlDoc->getElementsByTagName("attribute");
                    foreach ($attribute as $attribut) {
                        foreach ($attribut->childNodes as $child) {
                            if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "attribute_name") {
                                $attribute_name = trim($child->nodeValue);
                                continue;
                            }
                            if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "attribute_value_name") {
                                $attribute_value_name = trim($child->nodeValue);
                                continue;
                            }
                            if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "attribute_value_sortorder") {
                                $attribute_value_sortorder = trim($child->nodeValue);
                                continue;
                            }
                            if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "sortorder") {
                                $sortorder = trim($child->nodeValue);
                                continue;
                            }
                            if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "attribut_model") {
                                $attribut_model = trim($child->nodeValue);
                                continue;
                            }
                            if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "preisaufschlag") {
                                $preisaufschlag = trim($child->nodeValue);
                                continue;
                            }
                            if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "preisaufschlag_prefix") {
                                $preisaufschlag_prefix = trim($child->nodeValue);
                                continue;
                            }
                            if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "gewichtsaufschlag") {
                                $gewichtsaufschlag = trim($child->nodeValue);
                                continue;
                            }
                            if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "gewichtsaufschlag_prefix") {
                                $gewichtsaufschlag_prefix = trim($child->nodeValue);
                                continue;
                            }
                            if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "vpe") {
                                $attribut_vpe = trim($child->nodeValue);
                                continue;
                            }
                            if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "stock") {
                                $attribut_stock = trim($child->nodeValue);
                                continue;
                            }
                            if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "ean") {
                                $attribut_ean = trim($child->nodeValue);
                                continue;
                            }
                        }

                        $sql = "SELECT products_options_id FROM products_options WHERE products_options_name = '" . $db->real_escape_string($attribute_name) . "';";
                        $products_options_id = $db->query($sql)->fetch_object()->products_options_id;

                        if ($products_options_id) {
                            $vorhanden = true;
                        } else {
                            $vorhanden = false;
                        }

                        if ($vorhanden == false) {

                            $sql = " select @newid := max(products_options_id) from products_options; ";

                            if ($db->query($sql) == false) {
                                $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
                                return $view;
                            }

                            $sql = "insert into products_options SET products_options_name = '" . $db->real_escape_string($attribute_name) . "' , language_id = '2', products_options_id = ifnull(@newid,0) + 1 ;";
                            if ($db->query($sql) == false) {
                                $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
                                return $view;
                            }

                            $sql = "SELECT products_options_id FROM products_options WHERE products_options_name = '" . $db->real_escape_string($attribute_name) . "';";
                            $products_options_id = $db->query($sql)->fetch_object()->products_options_id;
                        }

                        //Attributwert

                        $sql = "SELECT a.products_options_values_id FROM products_options_values as a ";
                        $sql .= " inner join products_options_values_to_products_options as b on a.products_options_values_id = b.products_options_values_id ";
                        $sql .= "WHERE a.products_options_values_name = '" . $db->real_escape_string($attribute_value_name) . "';";
                        $products_options_values_id = $db->query($sql)->fetch_object()->products_options_values_id;

                        if ($products_options_values_id) {
                            $vorhanden = true;
                        } else {
                            $vorhanden = false;
                        }
                        if ($vorhanden == false) {
                            $sql = " select @newid := max(products_options_values_id) from products_options_values ;";
                            if ($db->query($sql) == false) {
                                $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
                                return $view;
                            }
                            $sql = "insert into products_options_values SET products_options_values_name = '" . $db->real_escape_string($attribute_value_name) . "' , language_id = '2', ";
                            $sql .= " products_options_values_id = ifnull(@newid,0) + 1 ; ";
                            $queries .= $sql;
                            if ($db->query($sql) == false) {
                                $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
                                return $view;
                            }

                            $sql = "SELECT max(products_options_values_id) as products_options_values_id FROM products_options_values WHERE products_options_values_name = '" . $db->real_escape_string($attribute_value_name) . "';";
                            $products_options_values_id = $db->query($sql)->fetch_object()->products_options_values_id;
                        }

                        //Artikelattribut

                        $sql = "SELECT products_options_values_to_products_options_id FROM products_options_values_to_products_options WHERE products_options_id = '" . $db->real_escape_string($products_options_id) . "'";
                        $sql .= " and products_options_values_id = '" . $db->real_escape_string($products_options_values_id) . "'; ";
                        $products_options_values_to_products_options_id = $db->query($sql)->fetch_object()->products_options_values_to_products_options_id;

                        if ($products_options_values_to_products_options_id) {
                            $vorhanden = true;
                        } else {
                            $vorhanden = false;
                        }

                        if ($vorhanden == false) {
                            $sql = " select @newid := max(products_options_values_to_products_options_id) from products_options_values_to_products_options ;";
                            if ($db->query($sql) == false) {
                                $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
                                return $view;
                            }

                            $sql = " insert into products_options_values_to_products_options SET products_options_id = '" . $db->real_escape_string($products_options_id) . "' , ";
                            $sql .= " products_options_values_id = '" . $db->real_escape_string($products_options_values_id) . "', ";
                            $sql .= " products_options_values_to_products_options_id = ifnull(@newid,0) + 1 ; ";
                            $queries .= $sql;
                            if ($db->query($sql) == false) {
                                $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
                                return $view;
                            }

                            $sql = "SELECT products_options_values_to_products_options_id FROM products_options_values_to_products_options WHERE products_options_id = '" . $db->real_escape_string($products_options_id) . "'";
                            $sql .= " and products_options_values_id = '" . $db->real_escape_string($products_options_values_id) . "'; ";
                            $products_options_values_to_products_options_id = $db->query($sql)->fetch_object()->products_options_values_to_products_options_id;
                        }

                        //Produktzuweisung

                        $sql = "SELECT products_attributes_id FROM products_attributes WHERE products_id = '" . $db->real_escape_string($products_id) . "' ";
                        $sql .= " and options_id = '" . $db->real_escape_string($products_options_id) . "' and options_values_id = '" . $db->real_escape_string($products_options_values_id) . "';";

                        $products_attributes_id = $db->query($sql)->fetch_object()->products_attributes_id;

                        if ($products_attributes_id) {
                            $vorhanden = true;
                        } else {
                            $vorhanden = false;
                        }

                        if ($vorhanden == false) {
                            $sql = "insert into products_attributes set products_id = '" . $db->real_escape_string($products_id) . "', ";
                            $sql.= " options_id = '" . $db->real_escape_string($products_options_id) . "', ";
                            $sql.= " options_values_id = '" . $db->real_escape_string($products_options_values_id) . "', ";
                            $sql.= " options_values_price = '" . $db->real_escape_string($preisaufschlag) . "', ";
                            $sql.= " options_values_weight = '" . $db->real_escape_string($gewichtsaufschlag) . "', ";
                            $sql.= " attributes_model = '" . $db->real_escape_string($attribut_model) . "', ";
                            $sql.= " attributes_stock = '" . $db->real_escape_string($attribut_stock) . "', ";
                            $sql.= " gm_ean = '" . $db->real_escape_string($attribut_ean) . "', ";
                            $sql.= " gm_vpe_value = '" . $db->real_escape_string($attribut_vpe) . "', ";
                            $sql.= " products_vpe_id = (select products_vpe from products where products_id = '" . $db->real_escape_string($products_id) . "'), ";
                            $sql.= " weight_prefix = '+', ";
                            $sql.= " sortorder = '" . $db->real_escape_string($sortorder) . "', ";
                            $sql.= " price_prefix = '+'; ";
                            $queries .= $sql;
                            if ($db->query($sql) == false) {
                                $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
                                return $view;
                            }
                        } else {
                            $sql = "update products_attributes set options_values_price = '" . $db->real_escape_string($preisaufschlag) . "', ";
                            $sql.= " options_values_weight = '" . $db->real_escape_string($gewichtsaufschlag) . "', ";
                            $sql.= " attributes_model = '" . $db->real_escape_string($attribut_model) . "', ";
                            $sql.= " attributes_stock = '" . $db->real_escape_string($attribut_stock) . "', ";
                            $sql.= " gm_ean = '" . $db->real_escape_string($attribut_ean) . "', ";
                            $sql.= " gm_vpe_value = '" . $db->real_escape_string($attribut_vpe) . "', ";
                            $sql.= " products_vpe_id = (select products_vpe from products where products_id = '" . $db->real_escape_string($products_id) . "'), ";
                            $sql.= " weight_prefix = '+', ";
                            $sql.= " sortorder = '" . $db->real_escape_string($sortorder) . "', ";
                            $sql.= " price_prefix = '+' ";
                            $sql.= " WHERE products_attributes_id = '" . $db->real_escape_string($products_attributes_id) . "'; ";
                            $queries .= $sql;
                            if ($db->query($sql) == false) {
                                $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
                                return $view;
                            }
                        }
                    }
					
					          // Eigenschaften
                    // erst mal alle alten zuweisungen lÃ¶schen

                    $sql = "delete from products_properties_combis where products_id = '" . $db->real_escape_string($products_id) . "'; ";
					          $sql .= "delete from products_properties_combis_values where products_properties_combis_id not in (SELECT products_properties_combis_id from products_properties_combis); ";
					          $sql .= "delete from products_properties_index where products_id = '" . $db->real_escape_string($products_id) . "'; ";
					          $sql .= "delete from products_properties_admin_select where products_id = '" . $db->real_escape_string($products_id) . "'; ";
                              $result = $db->multi_query($sql);
					          while ($db->next_result()) {
						          ;
                                  }
                    if ($result == false) {
                        $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
                        return $view;
                    }
					$ezaarray = array();
                    $properties = $xmlDoc->getElementsByTagName("properties");					
					          $preis_array = array();
					          $gewicht_array = array();
					          $vpe_array = array();
					          $stock_array = array();
					          $old_property_id = "";
					          $old_property_value_id = "";
					          $old_shop_prop_id = "";
					          $old_shop_prop_val_id = "";
							
					          if ($properties->length > 0)
					          {
						          foreach ($properties as $property) {
							          foreach ($property->childNodes as $child) {
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "property_name") {
									          $property_name = trim($child->nodeValue);							
									          continue;
								          }
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "property_id") {
									          $property_id = trim($child->nodeValue);							
									          continue;
								          }
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "property_language_id") {
									          $property_language_id = trim($child->nodeValue);							
									          continue;
								          }
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "property_value_language_id") {
									          $property_value_language_id = trim($child->nodeValue);							
									          continue;
								          }							
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "property_value_id") {
									          $property_value_id = trim($child->nodeValue);							
									          continue;
								          }
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "property_value_name") {
									          $property_value_name = trim($child->nodeValue);								
									          continue;
								          }
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "property_value_sortorder") {
									          $property_value_sortorder = trim($child->nodeValue);								
									          continue;
								          }                 
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "preisaufschlag") {
									          $preisaufschlag = trim($child->nodeValue);								
									          continue;
								          }
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "preisaufschlag_prefix") {
									          $preisaufschlag_prefix = trim($child->nodeValue);							
									          continue;
								          }
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "gewichtsaufschlag") {
									          $gewichtsaufschlag = trim($child->nodeValue);							
									          continue;
								          }
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "gewichtsaufschlag_prefix") {
									          $gewichtsaufschlag_prefix = trim($child->nodeValue);								
									          continue;
								          }
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "vpe") {
									          $property_vpe = trim($child->nodeValue);							
									          continue;
								          }
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "stock") {
									          $property_stock = trim($child->nodeValue);							
									          continue;
								          }
								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "shop_language_id") {
									          $shop_language_id = trim($child->nodeValue);							
									          continue;
								          }

								          if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "eza_property_id") {
									          $eza_property_id = trim($child->nodeValue);							
									          continue;
								          }
								
										  
							          }
									 
							           $property_language_id = $shop_language_id;
							           $property_value_language_id   = $shop_language_id;
		
					
							          if (($old_property_id == $property_id) and ($old_property_value_id == $property_value_id)){
								          $newlanguage = true;
								          $old_property_id = $property_id;
								          $old_property_value_id = $property_value_id;
							          }
							          else{
								          $newlanguage = false;
								          $old_property_id = $property_id;
								          $old_property_value_id = $property_value_id;
							          }
							
							          $sql = "SELECT properties_id FROM properties_description WHERE properties_name = '" . $db->real_escape_string($property_name) . "' And language_id = '". $db->real_escape_string($shop_language_id). "'; ";	
												
							          $properties_id = $db->query($sql)->fetch_object()->properties_id;					
					
				
							          if ($properties_id) {
								          $vorhanden = true;
							          } else {
								          $vorhanden = false;
							          }
							
							          if ($vorhanden == false) {

								          $sql = " select @newid := max(properties_id) from properties; ";

								          if ($db->query($sql) == false) {
									          $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
									          return $view;
								          }
								
								
								
								           if ($newlanguage){
										          $sql = "insert into properties_description SET properties_name = '" . $db->real_escape_string($property_name) . "' , language_id = '" . $db->real_escape_string( $property_language_id ) . "', properties_description.properties_id = '". $db->real_escape_string( $old_shop_prop_id ) . "'; ";								  
							
								           }else{
									          $sql = "insert into properties SET properties_id = ifnull(@newid,0) + 1 ; ";
									          $sql .= "insert into properties_description SET properties_name = '" . $db->real_escape_string($property_name) . "' , language_id = '2', properties_description.properties_id = ifnull(@newid,0) + 1 ; ";
								           }
					 
								          if ($db->multi_query($sql) == false) {
									          $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
									          return $view;
								          }
								
								          while ($db->next_result()) {
									          ;
								          }
						
								          $sql = "SELECT properties_id FROM properties_description WHERE properties_name = '" . $db->real_escape_string($property_name) . "' And language_id = '". $db->real_escape_string($shop_language_id)."';";
								
								          $properties_id = $db->query($sql)->fetch_object()->properties_id;

							          }
							          $old_shop_prop_id = $properties_id ;
							          //Eigenschaftswerte
						
							          $sql = "SELECT a.properties_values_id FROM properties_values as a ";
							          $sql .= " inner join properties_values_description as b on a.properties_values_id = b.properties_values_id ";
									  $sql .= " inner join properties as x on x.properties_id = a.properties_id ";
							          $sql .= "WHERE b.values_name = '" . $db->real_escape_string($property_value_name) . "' And language_id = '". $db->real_escape_string($shop_language_id)."' and x.properties_id = '".$db->real_escape_string($properties_id) ."';";
							          $properties_values_id = $db->query($sql)->fetch_object()->properties_values_id;

							          if ($properties_values_id) {
								          $vorhanden = true;
										  //Sortierung updaten
										  $sortiersql  = "UPDATE properties_values SET sort_order = '".$db->real_escape_string($property_value_sortorder )."' WHERE properties_values_id = '".$db->real_escape_string($properties_values_id)."'"; 

										    if ($db->query($sortiersql) == false) {
									          $view->init('1', 'SQL Fehler.', $db->error, $sortiersql, '', $xml, __FUNCTION__, $queries);
									          return $view;
								          }
									  array_push($ezaarray, array('pid' => $eza_property_id, 'values_id' => $properties_values_id));		
							          } else {
								          $vorhanden = false;
                                                                          
							          }
				
							          if ($vorhanden == false) {
								          $sql = " select @newid := max(properties_values_id ) from properties_values ;";
								          if ($db->query($sql) == false) {
									          $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
									          return $view;
								          }
					
							          if ($newlanguage){
							
							          $sql = "insert into properties_values_description SET values_name = '" . $db->real_escape_string($property_value_name) . "' , language_id = '". $db->real_escape_string( $property_value_language_id )  ."', ";
							          $sql .= " properties_values_id =  '". $db->real_escape_string($old_shop_prop_val_id ) ."'  ; ";
							          }else{

							          $sql = "insert into properties_values set properties_values_id = ifnull(@newid,0) + 1 , sort_order = '" . $db->real_escape_string($property_value_sortorder ) . "', properties_id = '" . $db->real_escape_string($properties_id) . "', value_price = '" . $db->real_escape_string($preisaufschlag) . "' ; ";
							          $sql .= "insert into properties_values_description SET values_name = '" . $db->real_escape_string($property_value_name) . "' , language_id = '2', ";
							          $sql .= " properties_values_id = ifnull(@newid,0) + 1 ; ";
							          }                      
							

								          $queries .= $sql;
								
								          if ($db->multi_query($sql) == false) {
									          $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
									          return $view;
								          }
								          while ($db->next_result()) {
									          ;
								          }
								          $sql = "SELECT max(properties_values_id) as properties_values_id FROM properties_values_description WHERE values_name = '" . $db->real_escape_string($property_value_name) . "';";
								          $properties_values_id = $db->query($sql)->fetch_object()->properties_values_id;   
                                                                          array_push($ezaarray, array('pid' => $eza_property_id, 'values_id' => $properties_values_id));		
							          }
								          $old_shop_prop_val_id = $properties_values_id ;						
							          //Artikeleigenschaften
							          if ($newlanguage == false)
							          {
								          $sql = "INSERT INTO products_properties_admin_select set products_id = '" .$db->real_escape_string($products_id). "', properties_id = '".$db->real_escape_string($properties_id)."', properties_values_id = '".$db->real_escape_string($properties_values_id)."'  ;";
								          if ($db->query($sql) == false) {
									          $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
									          return $view;
								          }
							          }
							          $preis_array[$db->real_escape_string($properties_values_id)] = $preisaufschlag;
							          $gewicht_array[$db->real_escape_string($properties_values_id)] =  $gewichtsaufschlag;
							          $vpe_array[$db->real_escape_string($properties_values_id)] = $property_vpe;
							          $stock_array[$db->real_escape_string($properties_values_id)] = $property_stock;
						          }
						
						          $crossjoinquery = "select distinct * from ";
						          $counter = 65;
						          $counter2 = 65;
						
								  $stmt = $db->query("SELECT properties_values_id, products_properties_admin_select_id from products_properties_admin_select where products_id = '".$db->real_escape_string($products_id)."' ORDER BY properties_values_id");
								  								  
								  $realeza = array();
							 
                      
                                while ($row = $stmt->fetch_row()) {
                                    foreach ($ezaarray as $eza){
                                        if ($row[0] == $eza["values_id"]){	
                                                array_push($realeza, array('pid' => $eza["pid"], 'admin' => $row[1]));  
                                                break;
                                        }										
                                    }

                                }
                                                                  

								$ezaarray = array();
	
						          $sql = "SELECT DISTINCT properties_id from products_properties_admin_select where products_id = '".$db->real_escape_string($products_id)."' ORDER By properties_id";
						          $stmt = $db->prepare($sql);
						          $stmt->execute();
						          $stmt->bind_result($prop_id);
                                              
							
						          //Artikelzuordnung
						          while ($stmt->fetch()) {						
							
							          $props_query = " select products_properties_admin_select_id as 'a" . chr($counter2). chr($counter) . "' from products_properties_admin_select as aa ";
							          $props_query .=" join properties_values aw on aa.properties_values_id = aw.properties_values_id ";
							          $props_query .=" join properties as a on a.properties_id = aw.properties_id where a.properties_id = '" .$db->real_escape_string($prop_id). "' and aa.products_id = '" .$db->real_escape_string($products_id). "' ";
										
                                                                   $orderbycounter = $orderbycounter +1;
							          $crossjoinquery.=  "(" . $props_query  . ") as " . chr($counter2). chr($counter) . "  cross join ";
							          $counter = $counter+1;
							          if($counter > 89){
								          $counter2 = $counter2 + 1;
								          $counter = 65;
							          }
						          }
                                                       
						          $crossjoinquery = substr($crossjoinquery, 0, strlen($crossjoinquery) - 11); 					
                                                          $crossjoinquery = $crossjoinquery ;
						          $stmt = $db->query($crossjoinquery);
						          $eza_base = "select properties_values.value_price,properties_values.properties_values_id, properties_values_description.values_name, properties.properties_id, properties_description.properties_name from properties_values 
									          JOIN products_properties_admin_select ON products_properties_admin_select.properties_values_id = properties_values.properties_values_id
									          JOIN properties_values_description ON properties_values_description.properties_values_id = properties_values.properties_values_id
									          JOIN properties on properties.properties_id = properties_values.properties_id
									          JOIN properties_description on properties_description.properties_id = properties.properties_id
									          WHERE properties_description.language_id = properties_values_description.language_id and properties_description.language_id = '2' AND products_properties_admin_select.products_properties_admin_select_id = ";
					
						          $fieldcount = $stmt->field_count;
						          $exesql = "";							
								
						          while ($row = $stmt->fetch_row()) {
							          //products_properties_combis
							          $sql = "INSERT INTO products_properties_combis set products_id = '" . $db->real_escape_string($products_id) . "', combi_price = ";
							          $val = 0;
							          $_preis = 0;
							          $_gewicht = 0;
							          $_vpe = 0 ;
							          $_stock = 0;
								  $comparer_string = "";
							          for ($i = 0; $i <= $fieldcount -1; $i++) {								
								      $eza_query = $eza_base . "'" . $row[$i] . "'";									
								      $pvid = $db->query($eza_query)->fetch_object()->properties_values_id;
									  
									  
									  
									  foreach($realeza as $reza) {	
                                                                                   if($reza["admin"] == $row[$i]){
                                                                                       $comparer_string  = $comparer_string .  $reza["pid"] .";";
										break;
                                                                                   }
									  
									  }
											
								

											  
								          //preis
								          foreach ($preis_array as $key=>$value)
								          {
									          if ($key == $pvid)
									          {
										          $_preis = $_preis + $value;
										          break;
									          }
								
								          }
								
								          //gewicht
								          foreach ($gewicht_array as $key=>$value)
								          {
									          if ($key == $pvid)
									          {
										          $_gewicht = $_gewicht + $value;
										          break;
									          }
								
								          }
							
								          //vpe
								          foreach ($vpe_array as $key=>$value)
								          {
									          if ($key == $pvid)
									          {
										          $_vpe  = $_vpe  + $value;
										          break;
									          }
								
								          }
														
								
							          }
                                                                  
									$comparer_string = substr($comparer_string, 0, strlen($comparer_string) - 1); 
									$comparer_string_array = split(';', $comparer_string);
									asort($comparer_string_array);
									$comparer_string = implode(';', $comparer_string_array);
									
									$erpnumber = "";
									$properties_ezas = $xmlDoc->getElementsByTagName("properties_eza");
									 $_stock = 0; 
									 $_eza_sort = 0;
									 $_eza_ship = 0;
                                     $_pricestatus = "calc";
									 $_ean = "";
									 if ($properties_ezas->length > 0)
									{
										 foreach ($properties_ezas as $properties_eza) {
											  foreach ($properties_eza->childNodes as $child) {
												  if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "WawiArtikelnummer") {
													  $properties_eza_erp_id = trim($child->nodeValue);							
													  continue;
												  }
												  
												  if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "ArtikelID") {
													  $properties_eza_products_id  = trim($child->nodeValue);							
													  continue;
												  }
												  
												  if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "Stock") {												
													  $eza_stock  = trim($child->nodeValue);							
													  continue;
												  }

												 if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "sort_order") {												
													  $eza_sort  = trim($child->nodeValue);							
													  continue;
												  }

												 if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "shippingtime") {												
													  $eza_ship  = trim($child->nodeValue);							
													  continue;
												  }
                                                if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "UseFinalPrice") {												
                                                    $UseFinalPrice = trim($child->nodeValue);							
                                                    continue;
                                                }
                                                  
                                                if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "VPE") {												
                                                    $eza_vpe  = trim($child->nodeValue);							
                                                    continue;
                                                }
                                                  
                                                if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "FinalPrice") {												
                                                    $eza_finalprice  = trim($child->nodeValue);							
                                                    continue;
                                                }
                                                  
                                                if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "FinalWeight") {												
                                                    $eza_finalweight  = trim($child->nodeValue);							
                                                    continue;
                                                }		
												
												if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "EAN") {
													$eza_ean = trim($child->nodeValue);
													continue;
												}										  
												  
												  
											  }
											  
											if ($properties_eza_products_id == $comparer_string){                                                                                              
												$erpnumber = $properties_eza_erp_id;																						
												$_stock = $eza_stock;
												$_eza_sort = $eza_sort;
												$_eza_ship = $eza_ship;
												$_ean = $eza_ean;
												if($UseFinalPrice == "True"){
													$_preis = $eza_finalprice;
													$_gewicht = $eza_finalweight;
													$_vpe = $eza_vpe;
													$_pricestatus = "fix";
												}
                                                break;
											}																						  
										
										  }			
											  
									 }
																						
                                                                            if ($erpnumber != ""){
                                                                                $sql .= "'" . $db->real_escape_string($_preis) . "' , combi_ean = '" . $db->real_escape_string($_ean) . "' , combi_weight = '" . $db->real_escape_string($_gewicht) . "', combi_quantity = '" . $db->real_escape_string($_stock) ."', vpe_value = '" . $db->real_escape_string($_vpe) . "', combi_model = '".$db->real_escape_string($erpnumber)."' , combi_shipping_status_id = '".$db->real_escape_string($_eza_ship)."' , sort_order = '".$db->real_escape_string($_eza_sort)."', combi_price_type = '". $db->real_escape_string($_pricestatus) ."',";
                                                                            }else{                                                                                
                                                                                $sql .= "'" . $db->real_escape_string($_preis) . "' , combi_ean = '" . $db->real_escape_string($_ean)  . "' , combi_weight = '" . $db->real_escape_string($_gewicht) . "', combi_quantity = '" . $db->real_escape_string($_stock) ."', vpe_value = '" . $db->real_escape_string($_vpe) . "'  , combi_shipping_status_id = '".$db->real_escape_string($_eza_ship)."' , sort_order = '".$db->real_escape_string($_eza_sort)."', combi_price_type = '". $db->real_escape_string($_pricestatus) ."',";
								            }
							           $sql .= "products_vpe_id = '". $this->GetProductsVPEID($products_vpe, $db) ."' ";

							          if ($db->query($sql) == false) {
								          $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
								          return $view;
							          }
							          //products_properties_combis_values + index
							          $sql = "INSERT INTO products_properties_combis_values set products_properties_combis_id = ";
							          $sql2 = "INSERT INTO products_properties_index set products_properties_combis_id = ";
							
							
							          for ($i = 0; $i <= $fieldcount -1; $i++) {
								          $eza_query = $eza_base . "'" . $row[$i] . "'";	
									
								          $dsql = " select max(products_properties_combis_id) as products_combis_id from products_properties_combis ;";

								          $products_combis_id = $db->query($dsql)->fetch_object()->products_combis_id;
								
								          $val = $db->query($eza_query)->fetch_object()->properties_values_id;
								          $pname = $db->query($eza_query)->fetch_object()->properties_name;
								          $vname = $db->query($eza_query)->fetch_object()->values_name;
								          $pid = $db->query($eza_query)->fetch_object()->properties_id;
								
								          $exesql .= $sql . " '". $db->real_escape_string($products_combis_id) ."' , properties_values_id = '" . $db->real_escape_string($val) . "' ; "; 										  
										  
								 
								          $exesql .= $sql2 . " '". $db->real_escape_string($products_combis_id) ."' , language_id = '2', properties_id = '" . $db->real_escape_string($pid) . "', properties_values_id = '" . $db->real_escape_string($val)  . "', properties_name = '" . $db->real_escape_string($pname) . "', values_name = '" . $db->real_escape_string($vname) . "', products_id = '" . $db->real_escape_string($products_id) . "'; ";
				
							          }							

						          }

						          if ($db->multi_query($exesql) == false) {
							           $view->init('1', 'SQL Fehler.', $db->error, $query, '', $xml, __FUNCTION__, $queries);
							          return $view;
						           }

						           while ($db->next_result()) {
							           ;
						           }
								   
					          }
					

                    $view->init('0', '', '', $artikelstatus, $xml, __FUNCTION__, $queries);
                } else {
                    $view->init('1', 'SQL Fehler.', $db->error, '', $xml, __FUNCTION__, $queries);
                }
            } else {
                $view->init('1', 'SQL Fehler.', $db->error, $queries, '', $xml, __FUNCTION__, $queries);
            }
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Anlegen des Artikels.', $e->__toString(), '', $xml, __FUNCTION__, $queries);
            return $view;
        }
    }
	
	function PDFFileLocation(RestServer $rest) {
        $view = new XMLView();
        $view->init('0', '', '', "/media/products/", '', __FUNCTION__, $sql);
        return $view;
    }

    function ExplosionImageLocation(RestServer $rest) {
        $view = new XMLView();
        $view->init('0', '', '', "/media/products/", '', __FUNCTION__, $sql);
        return $view;
    }

    function PDFFileUpload(RestServer $rest) {
        $view = new XMLView();
        try {
            $filename = $rest->getRequest()->getUri(4);
            $override = $rest->getRequest()->getUri(5);
            $filedata = $rest->getRequest()->getBody();

            $decodedfile = base64_decode(chunk_split($filedata));

            $filenamearray = split('[_.-]', $filename);
            $origfilename = "";
            for ($i = 0; $i < sizeof($filenamearray) - 1; $i++) {
                $origfilename .= $filenamearray[$i] . "_";
            }
            $origfilename = substr($origfilename, 0, -1);
            $origfilename .= "." . $filenamearray[sizeof($filenamearray) - 1];

            $path = DIR_FS_CATALOG . "media/products/";
			$ssl_enabled = false;
			if (ENABLE_SSL_CATALOG == 'true') $ssl_enabled = true;
			if ($ssl_enabled) 
				$webpath = HTTPS_CATALOG_SERVER;
			else
				$webpath = HTTP_SERVER;
            if (file_exists($path . "/" . $origfilename)) {
                if ($override != "true") {
                    $view->init('0', 'Datei existiert schon.', $webpath . $origfilename, '', $rest->getRequest()->getBody(), __FUNCTION__, '');
					
                    return $view;
                }
            }

            if (file_put_contents($path . "/" . $origfilename, $decodedfile)) {
                $view->init('0', '', '', $webpath . DIR_WS_CATALOG . "media/products/" . $origfilename, '', __FUNCTION__, '');
            } else {
                $view->init('1', 'Fehler beim Hochladen der PDF Datei.', $origfilename, '', $rest->getRequest()->getBody(), __FUNCTION__, '');
            }
			
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Hochladen der PDF Datei.', $e, '', $rest->getRequest()->getBody(), __FUNCTION__, '');
            return $view;
        }
    }

    function checkPicture(RestServer $rest) {
        $view = new XMLView();
        try {
            $filetype = $rest->getRequest()->getUri(1);
            $filename = $rest->getRequest()->getUri(4);

            $md5 = $rest->getRequest()->getBody();

            $filenamearray = split('[_.-]', $filename);
            $origfilename = "";
            for ($i = 0; $i < sizeof($filenamearray) - 1; $i++) {
                $origfilename .= $filenamearray[$i] . "_";
            }
            $origfilename = substr($origfilename, 0, -1);
            $origfilename .= "." . $filenamearray[sizeof($filenamearray) - 1];

            if ($filetype == "categories") {
                $path = DIR_FS_CATALOG . "images/categories/";
            }
            if ($filetype == "explosions") {
                $path = DIR_FS_CATALOG . "media/products/";
            }
            if ($filetype == "manufacturers") {
                $path = DIR_FS_CATALOG . "images/manufacturers/";
            }

            if ($filetype == "products") {
                $path = DIR_FS_CATALOG_ORIGINAL_IMAGES;
            }

            if (file_exists($path . "/" . $origfilename)) {
                $filename = $path . "/" . $origfilename;
                $imgbinary = fread(fopen($filename, "r"), filesize($filename));
                $base64 = base64_encode($imgbinary);
                $md5old = md5($base64);

                $erg = 'false';
                $ergtext = 'Datei existiert nicht';
                if ($md5 == $md5old) {
                    $erg = 'true';
                    $ergtext = 'Datei existiert schon.';
                }

                $view->init('0', $ergtext, $path . "/" . $origfilename, $erg, $md5 . ' --- ' . $md5old, __FUNCTION__, '');
                return $view;
            } else {
                $view->init('0', 'Datei existiert nicht', $path . "/" . $origfilename, 'false', $rest->getRequest()->getBody(), __FUNCTION__, '');
                return $view;
            }
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Überprüfen des Bildes', $e, '', $rest->getRequest()->getBody(), __FUNCTION__, '');
            return $view;
        }
    }

    function deleteEmptyCategories(RestServer $rest) {
       $view = new XMLView();
		try {
			$db = $rest->getParameter("db");	
			$cache_loeschen = $rest->getRequest()->getUri(4);
			$affectedRows = 0;
			$num = 0;
			$result;
			do{
				$num++;
				$this->WriteLine("Durchlauf " . $num);
			
				$sql = "delete categories_description from categories_description left join products_to_categories on categories_description.categories_id = products_to_categories.categories_id left join categories on categories_description.categories_id = categories.parent_id where categories.categories_id is null and products_to_categories.categories_id is null; delete categories from categories left join categories_description on categories_description.categories_id = categories.categories_id where categories_description.categories_id is null;";
          
		  		$this->WriteLine("deleteEmptyCategory " . $sql);
				$result = $db->multi_query($sql);
				$affectedRows = mysqli_affected_rows($db);
				$this->WriteLine("ROWS " . $affectedRows);
				// Flushen, da sonst spätere Queries nicht mehr funktionieren
                while ($db->next_result()) {;}
			}while($affectedRows > 0 && $result);
		    if ($result) {
				$this->WriteLine("Success");
                $view->init('0', '', '', '', '', __FUNCTION__, $sql);
				
            } else {
				$this->WriteLine("Fail");
                $view->init('1', 'Fehler beim Löschen der leeren Kategorien.', $db->error, '', '', __FUNCTION__, $sql);

            }
			
			if ($cache_loeschen == "true") {
				$this->clearCache($rest);
			}			
            return $view;
		} catch (Exception $e) {
			$this->WriteLine("Exception on delete");
            $view->init('1', 'Fehler beim Löschen der leeren Kategorien.', $e, '', $rest->getRequest()->getBody(), __FUNCTION__, '');
            return $view;
        }       
    }

    function uploadPicture(RestServer $rest) {
        $view = new XMLView();
        try {
            $filetype = $rest->getRequest()->getUri(1);
            $filename = $rest->getRequest()->getUri(4);
            $override = $rest->getRequest()->getUri(5);
            $filedata = $rest->getRequest()->getBody();

            $decodedfile = base64_decode(chunk_split($filedata));

            $filenamearray = split('[_.-]', $filename);
            $origfilename = "";
            for ($i = 0; $i < sizeof($filenamearray) - 1; $i++) {
                $origfilename .= $filenamearray[$i] . "_";
            }
            $origfilename = substr($origfilename, 0, -1);
            $origfilename .= "." . $filenamearray[sizeof($filenamearray) - 1];



            if ($filetype == "categories") {
                $path = DIR_FS_CATALOG . "images/categories/";
            }
            if ($filetype == "explosions") {
                $path = DIR_FS_CATALOG . "media/products/";
            }
            if ($filetype == "manufacturers") {
                $path = DIR_FS_CATALOG . "images/manufacturers/";
            }

            if ($filetype == "products") {
                $path = DIR_FS_CATALOG_ORIGINAL_IMAGES;
            }

            if (file_exists($path . "/" . $origfilename)) {
                if ($override != "true") {
                    $view->init('0', 'Datei existiert schon.', $path . "/" . $origfilename, 'true', $rest->getRequest()->getBody(), __FUNCTION__, '');
                    return $view;
                }
            }

            if (file_put_contents($path . "/" . $origfilename, $decodedfile)) {
                if ($filetype == "categories") {
                    $result = true;
                }
                if ($filetype == "explosions") {
                    $result = true;
                }
                if ($filetype == "manufacturers") {
                    $result = true;
                }
                if ($filetype == "products") {
                    $products_image_name = $origfilename;
                    // Disable use_trans_sid as xtc_href_link() does this manually
                    if (function_exists('ini_set')) {
                        ini_set('session.use_trans_sid', 0);
                    }

					$old_dir = dirname(__FILE__); // Save current directory path
					chdir(DIR_FS_ADMIN . "includes/classes/"); // Change directory to /admin/includes/classes/

                    include IMAGE_MANIPULATOR;

					chdir(DIR_FS_ADMIN); // Change directory to /admin/

                    require (DIR_FS_ADMIN . "includes/" . 'product_gallery_images.php');
                    require (DIR_FS_ADMIN . "includes/" . 'product_thumbnail_images.php');
                    require (DIR_FS_ADMIN . "includes/" . 'product_info_images.php');
                    require (DIR_FS_ADMIN . "includes/" . 'product_popup_images.php');

					chdir($old_dir); // Change directory to original directory

                    if (file_exists(DIR_FS_CATALOG_THUMBNAIL_IMAGES . $products_image_name)) {
                        unlink(DIR_FS_CATALOG_ORIGINAL_IMAGES . "/" . $origfilename);
                    } else {
                        $view->init('1', 'Fehler beim Verarbeiten des Bildes', $path . "/" . $origfilename, '', $rest->getRequest()->getBody(), __FUNCTION__, '');
                        return $view;
                    }
                    $result = true;
                }

                if ($result) {
                    $view->init('0', '', $path . "/" . $origfilename, 'false', '', __FUNCTION__, '');
                } else {
                    $view->init('1', 'Fehler beim Kopieren des Bildes', $path . "/" . $origfilename, '', '', __FUNCTION__, '');
                }
            } else {
                $view->init('1', 'Fehler beim Hochladen des Bildes', $path . "/" . $origfilename, '', $rest->getRequest()->getBody(), __FUNCTION__, '');
            }

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Hochladen des Bildes.', $e, '', $rest->getRequest()->getBody(), __FUNCTION__, '');
            return $view;
        }
    }

    function deleteCustomersPrices(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $sql = "delete from products_customers_price; alter table products_customers_price auto_increment = 1";
            if ($db->multi_query($sql)) {
                $view->init('0', '', '', '', '', __FUNCTION__, $sql);
            } else {
                $view->init('1', 'Fehler beim Löschen der Kundenpreise.', $db->error, '', '', __FUNCTION__, $sql);
            }
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Löschen der Kundenpreise.', $e->__toString(), '', '', __FUNCTION__, $sql);
            return $view;
        }
    }

    function copyCustomersPrices(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $sql = "delete from products_customers_price; alter table products_customers_price auto_increment = 1;insert into products_customers_price (select * from products_customers_price);";
            if ($db->multi_query($sql)) {
                $view->init('0', '', '', '', '', __FUNCTION__, $sql);
            } else {
                $view->init('1', 'Fehler beim Löschen der Kundenpreise.', $db->error, '', '', __FUNCTION__, $sql);
            }
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Löschen der Kundenpreise.', $e->__toString(), '', '', __FUNCTION__, $sql);
            return $view;
        }
    }

    function createCustomersPrices(RestServer $rest) {
        $view = new XMLView();
        try {
            $xml = $rest->getRequest()->getBody();
            $db = $rest->getParameter("db");

            $xmlDoc = new DomDocument();
            if (!($xmlDoc->loadXML($xml))) {
                $view->init('1', 'Keine XML Daten', '', '', $xml, __FUNCTION__, '');
                return $view;
            }

            $kundenpreise = $xmlDoc->getElementsByTagName("xtc_customers_price");

            $erfolgreich = 0;
            $fehler = 0;
            $counter = 0;
            $querys = "";
            foreach ($kundenpreise as $kundenpreis) {
                foreach ($kundenpreis->childNodes as $child) {
                    $counter++;
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "customers_cid") {
                        $customers_cid = trim($child->nodeValue);
                        continue;
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "products_model") {
                        $products_model = trim($child->nodeValue);
                        continue;
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "products_price") {
                        $products_price = trim($child->nodeValue);
                        continue;
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "amount") {
                        $amount = trim($child->nodeValue);
                        continue;
                    }
                }

                $sql = "select customers_id from customers where customers_cid = '" . $db->real_escape_string($customers_cid) . "'";
                $customers_id = $db->query($sql)->fetch_object()->customers_id;

                if (isset($customers_id) == false) {
                    continue;
                }

                $sql = "select products_id from products where products_model = '" . $db->real_escape_string($products_model) . "'";
                $products_id = $db->query($sql)->fetch_object()->products_id;

                if (isset($products_id) == false) {
                    continue;
                }

                $sql = "select products_customers_price from products_customers_price where products_id = '" . $db->real_escape_string($products_id) . "' and customers_id = '" . $db->real_escape_string($customers_id) . "' and amount = '" . $db->real_escape_string($amount) . "'";
                $products_customers_price = $db->query($sql)->fetch_object()->products_customers_price;


                if ($products_customers_price) {
                    $query = "update products_customers_price set price = '" . $db->real_escape_string($products_price) . "' where products_id = '" . $db->real_escape_string($products_id) . "' and customers_id = '" . $db->real_escape_string($customers_id) . "' and  amount = '" . $db->real_escape_string($amount) . "'";
                } else {
                    $query = "insert into products_customers_price (products_id, customers_id, price,amount) values ('" . $db->real_escape_string($products_id) . "', '" . $db->real_escape_string($customers_id) . "', '" . $db->real_escape_string($products_price) . "', '" . $db->real_escape_string($amount) . "')";
                }

                $querys .= $query . ";\n";
                $result = $db->query($query);


                if ($result == true) {
                    $erfolgreich++;
                } else {
                    $fehler++;
                    $querysfehler .= $query . ";\n";
                }
            }

            if ($fehler == 0) {
                $view->init('0', '', '', '', $xml, __FUNCTION__, $querys);
            } else {
                $view->init('1', 'Fehler beim Erstellen der Kundenpreise. Products_model : '. $products_model, $querysfehler, '', $xml, __FUNCTION__, $querys);
            }

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Erstellen der Kundenpreise. Products_model : '. $products_model, $e->__toString(), '', $xml, __FUNCTION__, $sql);
            return $view;
        }
    }

    function deletePicture(RestServer $rest) {
        $view = new XMLView();
        try {

            $picture_name = $rest->getRequest()->getUri(3);
            $filenamearray = split('[_.-]', $picture_name);
            $origfilename = "";
            for ($i = 0; $i < sizeof($filenamearray) - 1; $i++) {
                $origfilename .= $filenamearray[$i] . "_";
            }
            $origfilename = substr($origfilename, 0, -1);
            $origfilename .= "." . $filenamearray[sizeof($filenamearray) - 1];
            $picture_name = $origfilename;

            $verzeichnisse = array("../../../../images/product_images/info_images/",
                "../../../../images/product_images/gallery_images/",
                "../../../../images/product_images/popup_images/",
                "../../../../images/product_images/thumbnail_images/",
                "../../../../images/product_images/original_images/",
                "../../../../images/categories/");

            foreach ($verzeichnisse as $value) {
                $verz = opendir($value);
                while ($file = readdir($verz)) {
                    if ($file == $picture_name) {
                        $pfad = $value . $file;
                        unlink($pfad);
                    }
                }
                closedir($verz);
            }

            $view->init('0', '', '', $pfad, $picture_name, __FUNCTION__, '');
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Löschen der Bilder.', $e->__toString(), $pfad, $picture_name, __FUNCTION__, '');
            return $view;
        }
    }

    function deletePictures(RestServer $rest) {
        $view = new XMLView();
        try {

            $db = $rest->getParameter("db");

            $verzeichnisse = array("../../../../images/product_images/info_images/",
                "../../../../images/product_images/gallery_images/",
                "../../../../images/product_images/popup_images/",
                "../../../../images/product_images/thumbnail_images/",
                "../../../../images/product_images/original_images/",
                "../../../../images/categories/");

            foreach ($verzeichnisse as $value) {
                $verz = opendir($value);
                while ($file = readdir($verz)) {
                    if (($file != '.') && ($file != '..') && ($file != 'index.html') && ($file != 'noimage.gif') && ($file != 'icons'))
                        unlink($value . $file);
                }
                closedir($verz);
            }

            $sql = "DELETE from gm_gmotion_products; DELETE from gm_gmotion;";
            $db->multi_query($sql);

            $view->init('0', '', '', '', '', __FUNCTION__, '');
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Löschen der Bilder.', $e->__toString(), '', '', __FUNCTION__, '');
            return $view;
        }
    }

    function returnCustomerGroups(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $language_id = $rest->getRequest()->getUri(4);

            $document = new DOMDocument('1.0', "utf-8");
            $document->formatOutput = TRUE;
            $document->standalone = true;

            $xtc = $document->appendChild(
                    $document->createElement("XTC")
            );

            $sql = "SELECT customers_status_id as customers_group_id, customers_status_name as customers_group FROM customers_status where language_id = '" . $db->real_escape_string($language_id) . "' ";

            $result = $db->query($sql);

            if ($db->affected_rows == 0) {
                $view->init('1', 'Keine SQL-Ergebnismenge.', '', '', $language_id, __FUNCTION__, $sql);
                return $view;
            }

            while ($row = $result->fetch_assoc()) {
                $keys = array_keys($row);

                $groups = $xtc->appendChild(
                        $document->createElement("customer_status")
                );

                foreach ($keys as $key) {
                        $Cdata = $document->createCDATASection($row[$key]);                   
												$child = $document->createElement($key);
												$child->appendChild($Cdata);
												$groups->appendChild($child);
                }
            }

            $view->init('0', '', '', $document->savexml(), $language_id, __FUNCTION__, $sql);

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Holen der Kundengruppen', $e->__toString(), '', $language_id, __FUNCTION__, $sql);
            return $view;
        }
    }

    function returnCountries(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");

            $sql = "SELECT countries_name as countries_name FROM countries order by countries_name";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $stmt->bind_result($countries_name);
            $result = "";
            while ($stmt->fetch()) {
                $result .= $countries_name . ";";
            }
            $result = substr($result, 0, strlen($result) - 1);
            $view->init('0', '', '', $result, '', __FUNCTION__, $sql);
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Ändern des Artikelstatus.', $e->__toString(), '', '', __FUNCTION__, $sql);
            return $view;
        }
    }

    function returnGeoZones(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");

            $sql = "SELECT geo_zone_name as geo_zone_name FROM geo_zones order by geo_zone_name";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $stmt->bind_result($geo_zone_name);
            $result = "";
            while ($stmt->fetch()) {
                $result .= $geo_zone_name . ";";
            }
            $result = substr($result, 0, strlen($result) - 1);
            $view->init('0', '', '', $result, '', __FUNCTION__, $sql);
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Holen der GEOZonen.', $e->__toString(), '', '', __FUNCTION__, $sql);
            return $view;
        }
    }

    function returnZoneCountries(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $geo_zone_name = $rest->getRequest()->getBody();
            $sql = "SELECT a.countries_name as countries FROM countries as a ";
            $sql.="inner join zones_to_geo_zones as b on a.countries_id = b.zone_country_id ";
            $sql.="inner join geo_zones as c on b.geo_zone_id = c.geo_zone_id and c.geo_zone_name = ? ";
            $stmt = $db->prepare($sql);
            $stmt->bind_param('s', $geo_zone_name);
            $stmt->execute();
            $stmt->bind_result($countries_name);
            $result = "";
            while ($stmt->fetch()) {
                $result .= $countries_name . ";";
            }
            $result = substr($result, 0, strlen($result) - 1);
            $view->init('0', '', '', $result, '', __FUNCTION__, $sql);
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Holen der Zonenländer.', $e->__toString(), '', '', __FUNCTION__, $sql);
            return $view;
        }
    }

    function returnLanguages(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");

            $sql = "SELECT languages_id, name FROM languages order by name";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $stmt->bind_result($language_id, $name);
            $result = "";
            while ($stmt->fetch()) {
                $result .= $language_id . ",";
                $result .= $name . ";";
            }
            $result = substr($result, 0, strlen($result) - 1);
            $view->init('0', '', '', $result, '', __FUNCTION__, $sql);
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Holen der Sprachen.', $e->__toString(), '', '', __FUNCTION__, $sql);
            return $view;
        }
    }

    function changeProductStatus(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $products_model = $rest->getRequest()->getBody();
            $status = $rest->getRequest()->getUri(3);

            $sql = "SELECT products_id FROM products WHERE products_model = ?";
            $stmt = $db->prepare($sql);
            $stmt->bind_param('s', $products_model);
            $stmt->execute();
            $stmt->bind_result($products_id);
            $stmt->fetch();
            $stmt->close();

            if ($products_id) {
                $sql = "update products set products_status = ? where products_id = ? ";
                $stmt = $db->prepare($sql);
                $stmt->bind_param('ii', $status, $products_id);

                if ($stmt->execute()) {
                    $view->init('0', '', '', 'Zeilen betroffen: ' . $db->affected_rows, implode(";", array($status, $products_id)), __FUNCTION__, $sql);
                } else {
                    $view->init('1', 'Fehler beim Ändern des Artikelstatus.', $db->error, '', implode(";", array($status, $products_id)), __FUNCTION__, $sql);
                }
            } else {
                $view->init('1', 'Artikel nicht vorhanden.', '', '', implode(";", array($status, $products_model)), __FUNCTION__, '');
            }

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Ändern des Artikelstatus.', $e->__toString(), '', implode(";", array($status, $products_model)), __FUNCTION__, $sql);
            return $view;
        }
    }

    function createManufacturer(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $name = $rest->getRequest()->getBody();

            $sql = "select manufacturers_id from manufacturers where manufacturers_name = ?";
            $stmt = $db->prepare($sql);
            $stmt->bind_param('s', $name);
            $stmt->execute();
            $stmt->bind_result($manufacturers_id);
            $stmt->fetch();
            $stmt->close();

            if ($manufacturers_id) {
                $view->init('1', 'Hersteller ist bereits vorhanden.', '', '', $name, __FUNCTION__, $sql);
            } else {
                $sql = "insert into manufacturers (manufacturers_name, date_added) values (?, now())";
                $stmt = $db->prepare($sql);
                $stmt->bind_param('s', $name);

                if ($stmt->execute()) {
                    $view->init('0', '', '', 'Zeilen betroffen: ' . $db->affected_rows, $name, __FUNCTION__, $sql);
                } else {
                    $view->init('1', 'Fehler beim Erstellen des Herstellers.', $db->error, '', $name, __FUNCTION__, $sql);
                }
            }

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Erstellen des Herstellers.', $e->__toString(), '', $name, __FUNCTION__, $sql);
            return $view;
        }
    }

    function deleteManufacturer(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $id = $rest->getRequest()->getUri(3);

            $sql = "delete from manufacturers_info where manufacturers_id = '" . $db->real_escape_string($id) . "';delete from manufacturers where manufacturers_id = '" . $db->real_escape_string($id) . "';";

            if ($db->multi_query($sql)) {
                $view->init('0', '', '', '', $id, __FUNCTION__, $sql);
            } else {
                $view->init('1', 'Fehler beim Löschen des Herstellers.', $db->error, '', $id, __FUNCTION__, $sql);
            }

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Löschen des Herstellers.', $e->__toString(), '', $id, __FUNCTION__, $sql);
            return $view;
        }
    }

    function updateManufacturer(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $id = $rest->getRequest()->getUri(3);
            $body = $rest->getRequest()->getBody();

            $werte = preg_split('/[|]/', $body, -1);

            //Eintrag in manufacturers_info schon vorhanden?
            $sql = "select * from manufacturers_info where manufacturers_id = '" . $db->real_escape_string($id) . "';";
            $manufacturer = $db->query($sql)->fetch_object();

            if (is_null($manufacturer)) {
                $vorhanden = false;
            } else {
                $vorhanden = true;
            }

            $sql = "update manufacturers set manufacturers_name = '" . $db->real_escape_string($werte[0]) . "', manufacturers_image = '" . $db->real_escape_string($werte[1]) . "' where manufacturers_id = '" . $db->real_escape_string($id) . "';";
            if ($vorhanden == false) {
                $sql .= "insert into manufacturers_info (manufacturers_id, languages_id, manufacturers_url) values ('" . $db->real_escape_string($id) . "', 2, '" . $db->real_escape_string($werte[2]) . "');";
            } else {
                $sql .= "update manufacturers_info set manufacturers_url = '" . $db->real_escape_string($werte[2]) . "' where manufacturers_id = '" . $db->real_escape_string($id) . "';";
            }

            $db->multi_query($sql);
            $view->init('0', '', '', '', $body, __FUNCTION__, $sql);
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Ändern des Herstellers.', $e->__toString(), '', $body, __FUNCTION__, $sql);
            return $view;
        }
    }

    function returnManufacturers(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");

            $document = new DOMDocument('1.0', "utf-8");
            $document->formatOutput = TRUE;
            $document->standalone = true;

            $xtc = $document->appendChild(
                    $document->createElement("XTC")
            );

            $sql = "SELECT m.manufacturers_id, m.manufacturers_name, m.manufacturers_image, mi.manufacturers_url FROM `manufacturers` as m left outer join `manufacturers_info` as mi on m.manufacturers_id = mi.manufacturers_id where languages_id = '2' or languages_id Is null";

            $result = $db->query($sql);

            if ($db->affected_rows == 0) {
                $view->init('0', 'Keine SQL-Ergebnismenge.', '', '', '', __FUNCTION__, $sql);
                return $view;
            }

            while ($row = $result->fetch_assoc()) {
                $keys = array_keys($row);

                $groups = $xtc->appendChild(
                        $document->createElement("customer_status")
                );

                foreach ($keys as $key) {
										$Cdata = $document->createCDATASection($row[$key]);                   
										$child = $document->createElement($key);
										$child->appendChild($Cdata);
										$groups->appendChild($child);
                }
            }

            $view->init('0', '', '', $document->savexml(), '', __FUNCTION__, $sql);

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Holen der Hersteller', $e->__toString(), '', '', __FUNCTION__, $sql);
            return $view;
        }
    }

    function returnShops(RestServer $rest) {
        $view = new XMLView();
        $view->init('0', '', '', 'Nicht verfügbar.', '', __FUNCTION__, '');
        return $view;
    }

    function returnCustomersList(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $datum = $rest->getRequest()->getBody();

            $sql = "SELECT customers_id as customers_id from customers where customers_last_modified > ?";
            $stmt = $db->prepare($sql);
            $stmt->bind_param('s', $datum);
            $stmt->execute();
            $stmt->bind_result($customers_id);

            $result = "";
            while ($stmt->fetch()) {
                $result .= $customers_id . ";";
            }
            $result = substr($result, 0, strlen($result) - 1);
            $stmt->close();

            $view->init('0', '', '', $result, $datum, __FUNCTION__, $sql);
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Holen der Kundenliste.', $e->__toString(), '', $datum, __FUNCTION__, $sql);
            return $view;
        }
    }

    function returnShipmentList(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $language_id = $rest->getRequest()->getUri(4);

            $document = new DOMDocument('1.0', "utf-8");
            $document->formatOutput = TRUE;
            $document->standalone = true;

            $xtc = $document->appendChild(
                    $document->createElement("XTC")
            );

            $sql = "SELECT shipping_status_id, shipping_status_name FROM shipping_status where language_id = '" . $db->real_escape_string($language_id) . "' ";

            $result = $db->query($sql);

            if ($db->affected_rows == 0) {
                $view->init('1', 'Keine SQL-Ergebnismenge.', '', '', $language_id, __FUNCTION__, $sql);
                return $view;
            }

            while ($row = $result->fetch_assoc()) {
                $keys = array_keys($row);

                $groups = $xtc->appendChild(
                        $document->createElement("shipping_status")
                );

                foreach ($keys as $key) {                   
														$Cdata = $document->createCDATASection($row[$key]);                   
														$child = $document->createElement($key);
														$child->appendChild($Cdata);
														$groups->appendChild($child);                            
                }
            }

            $view->init('0', '', '', $document->savexml(), $language_id, __FUNCTION__, $sql);

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Holen des Lieferstatus.', $e->__toString(), '', $language_id, __FUNCTION__, $sql);
            return $view;
        }
    }

    function returnCustomers(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $nummernliste = $rest->getRequest()->getBody();

            $werte = preg_split('/;/', $nummernliste, -1, PREG_SPLIT_NO_EMPTY);
            $instring = "";
            foreach ($werte as $wert) {
                if (is_numeric($db->real_escape_string($wert))) {
                    $instring .= $wert . ",";
                }
            }
            $instring = substr($instring, 0, strlen($instring) - 1);

            $sql = "SELECT a.customers_id as Shopkundennummer, a.customers_cid as Wawikundennummer, b.entry_gender As Geschlecht, a.customers_fax As Fax, a.customers_last_modified As Geaendert, a.customers_status As Kundengruppennr, b.entry_company as Firma, b.entry_firstname as Vorname, b.entry_lastname as Nachname, ";
            $sql.="b.entry_street_address as Strasse, b.entry_postcode as PLZ, b.entry_city as Ort, b.entry_state as Bundesland, c.countries_name As Land, c.countries_iso_code_2 as LandISO, a.customers_email_address As EMail, a.customers_vat_id As Umsatzsteuernummer, a.customers_telephone as Telefon ";
            $sql.="from customers as a inner join address_book as b on a.customers_id = b.customers_id inner join countries as c on b.entry_country_id = c.countries_id  where a.customers_id in (" . $instring . ");";

            $result = $db->query($sql);

            if ($result == false) {
                $view->init('1', 'SQL-Fehler.', $db->error, '', $nummer, __FUNCTION__, $sql);
                return $view;
            }

            if ($db->affected_rows == 0) {
                $view->init('1', 'Keine SQL-Ergebnismenge.', $instring, '', $nummer, __FUNCTION__, $sql);
                return $view;
            }

            $document = new DOMDocument('1.0', "utf-8");
            $document->formatOutput = TRUE;
            $document->standalone = true;

            $xtc = $document->appendChild(
                    $document->createElement("XTC")
            );

            while ($row = $result->fetch_assoc()) {
                $keys = array_keys($row);

                $kunde = $xtc->appendChild(
                        $document->createElement("Kunde")
                );

                foreach ($keys as $key) { 
										$wert = $row[$key];
										$Cdata = $document->createCDATASection($wert);                   
										$child = $document->createElement($key);
										$child->appendChild($Cdata);
										$kunde->appendChild($child);
                }
            }

            $view->init('0', '', $instring, $document->saveXML(), $nummernliste, __FUNCTION__, $sql);
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Holen der Kunden.', $e->__toString(), '', $nummernliste, __FUNCTION__, $sql);
            return $view;
        }
    }

    function updateCustomer(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $xml = $rest->getRequest()->getBody();
            $shopid = $rest->getRequest()->getUri(2);

            $xmlDoc = new DomDocument();

            if (!($xmlDoc->loadXML($xml))) {
                $view->init('1', 'Keine XML Daten', '', '', $xml, __FUNCTION__, '');
                return $view;
            }

            $kunden = $xmlDoc->getElementsByTagName("Kunde");

            foreach ($kunden as $kunde) {
                foreach ($kunde->childNodes as $child) {
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "Nachname") {
                        $nachname = trim($child->nodeValue);
                        continue;
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "Wawikundennr") {
                        $wawikundennr = trim($child->nodeValue);
                        continue;
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "Kundengruppennr") {
                        $kundengrnr = trim($child->nodeValue);
                        continue;
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "Firma") {
                        $firma = trim($child->nodeValue);
                        continue;
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "Vorname") {
                        $vorname = trim($child->nodeValue);
                        continue;
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "Strasse") {
                        $strasse = trim($child->nodeValue);
                        continue;
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "PLZ") {
                        $plz = trim($child->nodeValue);
                        continue;
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "Ort") {
                        $ort = trim($child->nodeValue);
                        continue;
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "Email") {
                        $email = trim($child->nodeValue);
                        continue;
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "Telefon") {
                        $telefon = trim($child->nodeValue);
                        continue;
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "Umsatzsteuernummer") {
                        $umst = trim($child->nodeValue);
                        continue;
                    }
                }

                $query = "UPDATE customers set ";
                $query .= " customers_lastname='" . $nachname . "', ";
                $query .= " customers_cid='" . $wawikundennr . "', ";
                $query .= " customers_status='" . $kundengrnr . "', ";
                $query .= " customers_firstname='" . $vorname . "', ";
                $query .= " customers_email_address='" . $email . "', ";
                $query .= " customers_telephone='" . $telefon . "' ";
                $query .= " where customers_id = '" . $shopid . "'; ";

                $query .= "UPDATE address_book set ";
                $query .= " entry_company='" . $firma . "', ";
                $query .= " entry_firstname='" . $vorname . "', ";
                $query .= " entry_lastname='" . $nachname . "', ";
                $query .= " entry_street_address='" . $strasse . "', ";
                $query .= " entry_postcode='" . $plz . "', ";
                $query .= " entry_city='" . $ort . "' ";
                $query .= " where customers_id = '" . $shopid . "' ";

                if ($db->multi_query($query)) {
                    $view->init('0', '', '', '', $xml, __FUNCTION__, $query);
                } else {
                    $view->init('1', 'Fehler beim Ändern des Kunden.', $db->error, '', $xml, __FUNCTION__, $query);
                }

                return $view;
            }
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Ändern des Kunden.', $e->__toString(), '', $xml, __FUNCTION__, $query);
            return $view;
        }
    }

    function updateCustomersCID(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $customers_id = $rest->getRequest()->getUri(2);
            $customers_cid = $rest->getRequest()->getUri(4);

            $sql = "update customers set customers_cid = ? where customers_id = ?";
            $stmt = $db->prepare($sql);
            $stmt->bind_param('si', $customers_cid, $customers_id);

            if ($stmt->execute()) {
                $view->init('0', '', '', 'Zeilen betroffen: ' . $db->affected_rows, implode(";", array($customers_id, $customers_cid)), __FUNCTION__, $sql);
            } else {
                $view->init('1', 'Fehler beim Ändern der CID.', $db->error, '', implode(";", array($customers_id, $customers_cid)), __FUNCTION__, $sql);
            }

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Ändern der CID.', $e->__toString(), '', implode(";", array($customers_id, $customers_cid)), __FUNCTION__, $sql);
            return $view;
        }
    }

    function updateQuantity(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");

            $split = explode(";", $rest->getRequest()->getBody(), -1);
            $products_model = implode(";", $split);

            $split = explode(";", $rest->getRequest()->getBody());
            $quantity = $split[sizeof($split) - 1];

            $sql = "SELECT products_id FROM products WHERE products_model = ?";
            $stmt = $db->prepare($sql);
            $stmt->bind_param('s', $products_model);
            $stmt->execute();
            $stmt->bind_result($products_id);
            $stmt->fetch();
            $stmt->close();

            if ($products_id) {
                $sql = "update products set products_quantity = ? where products_id = ? ";
                $stmt = $db->prepare($sql);
                $stmt->bind_param('di', $quantity, $products_id);

                if ($stmt->execute()) {
                    $view->init('0', '', '', 'Zeilen betroffen: ' . $db->affected_rows, implode(";", array($quantity, $products_id)), __FUNCTION__, $sql);
                } else {
                    $view->init('1', 'Fehler beim Ändern der Artikelmenge.', $db->error, '', implode(";", array($quantity, $products_id)), __FUNCTION__, $sql);
                }
            } else {
                $view->init('1', 'Artikel nicht vorhanden.', '', '', implode(";", array($quantity, $products_model)), __FUNCTION__, '');
            }

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Ändern der Artikelmenge.', $e->__toString(), '', implode(";", array($quantity, $products_id)), __FUNCTION__, $sql);
            return $view;
        }
    }

    function updatePrice(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");

            $split = explode(";", $rest->getRequest()->getBody(), -1);
            $products_model = implode(";", $split);

            $split = explode(";", $rest->getRequest()->getBody());
            $price = $split[sizeof($split) - 1];

            $sql = "SELECT products_id FROM products WHERE products_model = ?";
            $stmt = $db->prepare($sql);
            $stmt->bind_param('s', $products_model);
            $stmt->execute();
            $stmt->bind_result($products_id);
            $stmt->fetch();
            $stmt->close();

            if ($products_id) {
                $sql = "update products set products_price = ? where products_id = ? ";
                $stmt = $db->prepare($sql);
                $stmt->bind_param('di', $price, $products_id);

                if ($stmt->execute()) {
                    $view->init('0', '', '', 'Zeilen betroffen: ' . $db->affected_rows, implode(";", array($price, $products_id)), __FUNCTION__, $sql);
                } else {
                    $view->init('1', 'Fehler beim Ändern des Artikelpreises.', $db->error, '', implode(";", array($price, $products_id)), __FUNCTION__, $sql);
                }
            } else {
                $view->init('1', 'Artikel nicht vorhanden.', '', '', implode(";", array($price, $products_model)), __FUNCTION__, '');
            }

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Ändern des Artikelpreises.', $e->__toString(), '', implode(";", array($price, $products_id)), __FUNCTION__, $sql);
            return $view;
        }
    }

    function deleteProduct(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $products_model = $rest->getRequest()->getBody();

            $sql = "SELECT products_id FROM products WHERE products_model = ?";
            $stmt = $db->prepare($sql);
            $stmt->bind_param('s', $products_model);
            $stmt->execute();
            $stmt->bind_result($products_id);
            $stmt->fetch();
            $stmt->close();

            if ($products_id) {
                // Kundengruppen holen
                $sql = "SELECT customers_status_id FROM customers_status group by customers_status_id";
                $stmt = $db->prepare($sql);
                $stmt->execute();
                $stmt->bind_result($customers_status_id);
                $sql = "";
                while ($stmt->fetch()) {
                    $sql .= "delete from personal_offers_by_customers_status_" . $customers_status_id . " where products_id='" . $products_id . "';";
                }
                $stmt->close();

                $sql .= "delete from products_xsell where products_id = '" . $products_id . "'; ";
                $sql .= "delete from products_to_categories where products_id = '" . $products_id . "'; ";
                $sql .= "delete from categories_index where products_id = '" . $products_id . "';";
                $sql .= "delete from specials where products_id = '" . $products_id . "'; ";
                $sql .= "delete from products_description where products_id = '" . $products_id . "'; ";
                //$sql .= "delete from products_attributes_download where products_id = '" . $products_id . "'; ";
                $sql .= "delete from products_attributes where products_id = '" . $products_id . "'; ";
                $sql .= "delete from products where products_id = '" . $products_id . "'; ";

                if ($db->multi_query($sql)) {
                    $view->init('0', '', '', '', $products_id, __FUNCTION__, $sql);
                } else {
                    $view->init('1', 'Artikel konnte nicht gelöscht werden.', $db->error, '', $products_id, __FUNCTION__, $sql);
                }
            } else {
                $view->init('1', 'Artikel nicht vorhanden.', '', '', $products_model, __FUNCTION__, '');
            }



            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Artikel konnte nicht gelöscht werden.', $e->__toString(), '', '', __FUNCTION__, '');
            return $view;
        }
    }

    function deleteCategorie(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $categories_id = $rest->getRequest()->getBody();

            if ($categories_id) {

                $sql = "delete from categories_description where categories_id = '" . $categories_id . "';";
                $sql .= "delete from categories where categories_id not in (select categories_id from categories_description);";
                $sql .= "delete from products_to_categories where categories_id not in (select categories_id from categories_description);";

                $sql .= "delete from categories_index where products_id not in (select products_id from products_to_categories);";
                $sql .= "delete from specials where products_id  not in (select products_id from products_to_categories);";
                $sql .= "delete from products_description where products_id  not in (select products_id from products_to_categories);";
                $sql .= "delete from products_attributes_download where products_id  not in (select products_id from products_to_categories);";
                $sql .= "delete from products_attributes where products_id  not in (select products_id from products_to_categories);";
                $sql .= "delete from products where products_id  not in (select products_id from products_to_categories);";

                if ($db->multi_query($sql)) {
                    $this->clearCache($rest);
                    $view->init('0', '', '', '', $cat_id, __FUNCTION__, $sql);
                } else {
                    $view->init('1', 'Kategorie konnte nicht gelöscht werden.', $db->error, '', $categories_id, __FUNCTION__, $sql);
                }
            } else {
                $view->init('1', 'Kategorie nicht vorhanden.', '', '', $categories_id, __FUNCTION__, '');
            }


            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Artikel konnten nicht gelöscht werden.', $e->__toString(), '', '', __FUNCTION__, '');
            return $view;
        }
    }

    function deleteCategoryAssignments(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $categories_id = $rest->getRequest()->getBody();

            if ($categories_id) {

                $sql = "delete from products_to_categories where categories_id =  " . $categories_id . ";";


                $stmt = $db->prepare($sql);

                if ($stmt->execute()) {
                    $view->init('0', '', '', '', $cat_id, __FUNCTION__, $sql);
                } else {
                    $view->init('1', 'Kategoriezuordnungen konnte nicht gelöscht werden.', $db->error, '', $categories_id, __FUNCTION__, $sql);
                }
            } else {
                $view->init('1', 'Kategorie nicht vorhanden.', '', '', $categories_id, __FUNCTION__, '');
            }


            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Kategoriezuordnungen konnten nicht gelöscht werden.', $e->__toString(), '', '', __FUNCTION__, '');
            return $view;
        }
    }

    function deleteProducts(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            // Kundengruppen holen
            $sql = "SELECT customers_status_id FROM customers_status group by customers_status_id";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $stmt->bind_result($customers_status_id);
            $sql = "";
            while ($stmt->fetch()) {
                $sql .= "delete from personal_offers_by_customers_status_" . $customers_status_id . ";";
            }
            $stmt->close();

            $sql .= "delete from products;";
            $sql .= "delete from products_description;";
            $sql .= "delete from products_attributes_download;";
            $sql .= "delete from products_attributes;";
            $sql .= "delete from products_images;";
            $sql .= "delete from products_to_categories;";
            $sql .= "delete from categories;";
            $sql .= "delete from categories_description;";
            $sql .= "delete from specials;";
            $sql .= "delete from products_xsell;";
            $sql .= "delete from products_xsell_grp_name;";
            $sql .= "delete from categories_index;";
            $sql .= "delete from gm_gmotion;";
            $sql .= "delete from gm_gmotion_products;";
			$sql .= "delete from products_properties_admin_select;";
			$sql .= "delete from products_properties_combis;";
			$sql .= "delete from products_properties_combis_values;";
			$sql .= "delete from products_properties_index;";

            if ($db->multi_query($sql)) {
                $view->init('0', '', '', '', '', __FUNCTION__, $sql);
            } else {
                $view->init('1', 'Artikel konnten nicht gelöscht werden.', $db->error, '', '', __FUNCTION__, $sql);
            }

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Artikel konnten nicht gelöscht werden.', $e->__toString(), '', '', __FUNCTION__, '');
            return $view;
        }
    }

    function clearCache(RestServer $rest) {
        $view = new XMLView();
        try {
            $coo_cache_control = MainFactory::create_object('CacheControl');
            $coo_cache_control->clear_cache();
            $coo_cache_control->clear_data_cache();
            $coo_cache_control->rebuild_categories_submenus_cache();
            $coo_cache_control->clear_content_view_cache();
            $coo_cache_control->clear_templates_c();

            $view->init('0', '', '', '', '', __FUNCTION__, '');
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Cache konnte nicht geleert werden.', $e->__toString(), '', '', __FUNCTION__, '');
            return $view;
        }
    }

    function rebuildAllFeatureIndex(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
			
            $db->query("delete from categories_index");

            $stmt = $db->prepare("SELECT products_id from products");
            $stmt->execute();
            $stmt->bind_result($products_id);
            $products_ids = array();

            while ($stmt->fetch()) {
                $coo_feature_handler = MainFactory::create_object('CategoriesIndex');
                $coo_feature_handler->build_categories_index($products_id);
                $products_ids[$products_id] = $products_id;
            }

            $stmt->close();
            $view->init('0', '', '', implode(";", $products_ids), '', __FUNCTION__, '');

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Feature Index konnte nicht neu erstellt werden.', $e->__toString(), '', '', __FUNCTION__, '');
            return $view;
        }
    }

    function rebuildFeatureIndex(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $products_model = $rest->getRequest()->getBody();
		
			
            $sql = "SELECT products_id FROM products WHERE products_model = ?";
            $stmt = $db->prepare($sql);
            $stmt->bind_param('s', $products_model);
            $stmt->execute();
            $stmt->bind_result($products_id);
            $stmt->fetch();
            $stmt->close();

            if ($products_id) {
                $sql = "delete from categories_index WHERE products_id = ?";
                $stmt = $db->prepare($sql);
                $stmt->bind_param('i', $products_id);
                $stmt->execute();

                $coo_feature_handler = MainFactory::create_object('CategoriesIndex');
                $coo_feature_handler->build_categories_index($products_id);

                $view->init('0', '', '', '', $products_id, __FUNCTION__, $sql);
            } else {
                $view->init('1', 'Artikel nicht vorhanden.', '', '', $products_model, __FUNCTION__, '');
            }


            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Feature Index konnte nicht neu erstellt werden.', $e->__toString(), '', $products_model, __FUNCTION__, '');
            return $view;
        }
    }

    function changeOrderStatus(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $orders_id = $rest->getRequest()->getUri(2);
            $status = $rest->getRequest()->getUri(4);
            $sql = "update orders set orders_status = '" . $db->real_escape_string($status) . "' where orders_id = '" . $db->real_escape_string($orders_id) . "'";
			$stmt = $db->prepare($sql);

            if ($stmt->execute()) {
                $view->init('0', '', '', 'Zeilen betroffen: ' . $db->affected_rows, implode(";", array($status, $orders_id)), __FUNCTION__, $sql);
            } else {
                $view->init('1', 'Fehler beim Ändern des Bestellstatus.', $db->error, '', $params, __FUNCTION__, $sql);
            }
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Ändern des Bestellstatus.', $e->__toString(), '', $params, __FUNCTION__, $sql);
            return $view;
        }
    }

    function changeOrderStatusComment(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $orders_id = $rest->getRequest()->getUri(2);
            $status = $rest->getRequest()->getUri(4);
            $comment = $rest->getRequest()->getBody();
            $sql = "update orders set orders_status = " . $db->real_escape_string($status) . ", comments = '" . $db->real_escape_string($comment) . "' where orders_id = " . $db->real_escape_string($orders_id);
            $stmt = $db->prepare($sql);


            if ($stmt->execute()) {
                $sql2 = "INSERT INTO orders_status_history (orders_id,orders_status_ID, date_added,customer_notified,comments) VALUES (" . $db->real_escape_string($orders_id) . "," . $db->real_escape_string($status) . ", '" . date("Y-m-d H:i:s") . "',0,'" . $db->real_escape_string(str_replace("_", " ", $comment)) . "')";
                $stmt = $db->prepare($sql2);
                if ($stmt->execute()) {
                    $view->init('0', '', '', '', implode(";", array($status, $orders_id)), __FUNCTION__, '');
                } else {
                    $view->init('1', 'Fehler beim Ändern des Bestellstatus.(Kommentar)', $db->error, '', $params, __FUNCTION__, $sql);
                }
            } else {
                $view->init('1', 'Fehler beim Ändern des Bestellstatus.(Kommentar)', $db->error, '', $params, __FUNCTION__, $sql);
            }

            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Ändern des Bestellstatus.(Kommentar)', $e->__toString(), '', $params, __FUNCTION__, $sql);
            return $view;
        }
    }

    function returnOrdersList(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $param = $db->real_escape_string($rest->getRequest()->getBody());

            $status = str_replace(";", ",", $param);

            $sql = "SELECT orders_id as orders_id FROM orders where orders_status in (" . $status . ")";
            $result = $db->query($sql);
            $strlist = "";
            while ($obj = $result->fetch_object()) {
                $strlist.= $obj->orders_id . ";";
            }
            $strlist = substr($strlist, 0, strlen($strlist) - 1);

            $view->init('0', '', '', $strlist, $status, __FUNCTION__, $sql);
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Abrufen der Bestellungen.', $e->__toString(), '', $status, __FUNCTION__, $sql);
            return $view;
        }
    }

    function returnOrder(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");
            $nummer = $rest->getRequest()->getUri(2);


            $document = new DOMDocument('1.0', "utf-8");
            $document->formatOutput = TRUE;
            $document->standalone = true;

            $xtc = $document->appendChild(
                    $document->createElement("XTC")
            );

            $sql = "SELECT a.*,b.customers_gender, '' as Gruppe, '' as Versandart, c.banktransfer_owner,";
            $sql.="c.banktransfer_number, c.banktransfer_bankname, c.banktransfer_blz, ifnull(d.sepa_iban, '') as sepa_iban, ifnull(d.sepa_bic, '') as sepa_bic, ifnull(d.sepa_owner, '') as sepa_owner, ifnull(d.sepa_bankname, '') as sepa_bankname ";
            $sql.="FROM orders as a inner join customers as b on a.customers_id = b.customers_id ";
            $sql.="left outer join banktransfer as c on a.orders_id = c.orders_id ";
			$sql.="left outer join sepa as d on a.orders_id = d.orders_id ";
            $sql.="WHERE a.orders_id = '" . $db->real_escape_string($nummer) . "'";

            $result = $db->query($sql);

            if ($db->affected_rows == 0) {
                $view->init('1', 'Keine SQL-Ergebnismenge.', '', '', $nummer, __FUNCTION__, $sql);
                return $view;
            }

            while ($row = $result->fetch_assoc()) {
                $keys = array_keys($row);

                // Bestellung schreiben

                $orders = $xtc->appendChild(
                        $document->createElement("ORDERS")
                );
                foreach ($keys as $key) {
										$wert = $row[$key];
                    $Cdata = $document->createCDATASection($wert);                   
										$child = $document->createElement($key);
										$child->appendChild($Cdata);
										$orders->appendChild($child);
                }

                $position = 1;

              
                //Alle möglichen Steuerarten für das Land raussuchen.
                                
                $sql =  "SELECT geo.geo_zone_id, tr.tax_rates_id, tr.tax_class_id, tr.tax_rate FROM orders AS a ";
                $sql .= "JOIN countries as ct on ct.countries_iso_code_2 = a.billing_country_iso_code_2 ";
                $sql .= "JOIN zones_to_geo_zones as geo ON geo.zone_country_id = ct.countries_id ";
                $sql .= "JOIN tax_rates AS tr ON tr.tax_zone_id = geo.geo_zone_id ";
                $sql .= "WHERE a.orders_id = '". $db->real_escape_string($nummer) ."'";
                
                 $taxresult = $db->query($sql);
                
                $taxarray = array();
                
                while($taxrow = $taxresult->fetch_assoc()){
                    array_push($taxarray, $taxrow);                                      
                }
                
                 // Bestellpositionen abrufen
				$sql = "SELECT DISTINCT orders_products_id, p.products_tax_class_id,orders_id,op.products_id, IFNULL(p.products_model, op.products_model) AS products_model ,products_name,op.products_price,products_discount_made,products_shipping_time,final_price,products_tax,op.products_quantity,allow_tax  FROM orders_products as op LEFT JOIN products as p ON p.products_id = op.products_id WHERE orders_id='" . $db->real_escape_string($nummer) . "'";
				$result = $db->query($sql);

				while ($row2 = $result->fetch_assoc()) {
					$keys2 = array_keys($row2);

					$orders_products = $xtc->appendChild(
							$document->createElement("ORDERS_PRODUCTS")
					);

					foreach ($keys2 as $key2) {
                                                 
                                            if(($key2 == "products_tax_class_id")){
                                                continue;
                                            }
                                            $wert2 = $row2[$key2];
                                            $Cdata = $document->createCDATASection($wert2);                   
                                            $child = $document->createElement($key2);
                                            $child->appendChild($Cdata);
                                            $orders_products->appendChild($child);	
					}
                                        
                                        foreach($taxarray as $key=>$taxrow){
                                            if(($row2["products_tax_class_id"] == $taxrow["tax_class_id"]) && ($row2["products_tax"] == $taxrow["tax_rate"])){
                                                $nodeElement = $document->getElementsByTagName("products_tax");
                                                if ($nodeElement->length !=0){ 
                                                    $wert2 = $row2["products_tax"];
                                                    $nodeElement->item(0)->Text = $wert2; 
                                                    
                                                    $wert2 = $taxrow["geo_zone_id"];
                                                    $Cdata = $document->createCDATASection($wert2);                   
                                                    $child = $document->createElement("geo_zone_id");
                                                    $child->appendChild($Cdata);
                                                    $orders_products->appendChild($child);

                                                    $wert2 = $taxrow["tax_rates_id"];
                                                    $Cdata = $document->createCDATASection($wert2);                   
                                                    $child = $document->createElement("tax_rates_id");
                                                    $child->appendChild($Cdata);
                                                    $orders_products->appendChild($child);
                                                    
                                                    
                                                }
                                            }
                                            
                                            
                                        }
                                     

					$position++;
				}
				
                // Versand abrufen
                //$sql = "SELECT orders_total_id, orders_id, value, class FROM orders_total WHERE orders_id='" . $db->real_escape_string($nummer) . "'";

                $sql = "SELECT orders_total_id, orders_id, value, class FROM orders_total WHERE orders_id='" . $db->real_escape_string($nummer) . "' ";
                $sql .= " UNION ";
                $sql .= " SELECT max(orders_total_id) + 1 as orders_total_id, orders_id, CAST((SELECT IFNULL(configuration_value, '') from configuration where configuration_key = (SELECT UPPER(CONCAT('MODULE_SHIPPING_', SUBSTRING_INDEX(shipping_class, '_', 1 ),'_TAX_CLASS')) as versandart from orders where orders_id = '" . $db->real_escape_string($nummer) . "') LIMIT 1) as CHAR(10)) as value, 'sync4_versand_mwst' as class from orders_total WHERE orders_id='" . $db->real_escape_string($nummer) . "' ";

                $result = $db->query($sql);

                while ($row3 = $result->fetch_assoc()) {
                    $keys3 = array_keys($row3);
                    $orders_products = $xtc->appendChild(
                            $document->createElement("ORDERS_TOTAL")
                    );

                    foreach ($keys3 as $key3) {
												$wert3 = $row3[$key3];
												$Cdata = $document->createCDATASection($wert3);                   
												$child = $document->createElement($key3);
												$child->appendChild($Cdata);
												$orders_products->appendChild($child);
                    }
                }

                // Attribute holen
                $sql = "SELECT pa.orders_id, pa.orders_products_id, pa.products_options, pa.products_options_values, p.products_model FROM orders_products_attributes as pa join orders_products as p on pa.orders_id = p.orders_id and pa.orders_products_id = p.orders_products_id WHERE pa.orders_id='" . $db->real_escape_string($nummer) . "' and pa.products_options <> '' and pa.products_options_values <> ''";
                $result = $db->query($sql);

                while ($row4 = $result->fetch_assoc()) {
                    $keys4 = array_keys($row4);
                    $orders_products_attributes = $xtc->appendChild(
                            $document->createElement("ORDERS_ATTRIBUTES")
                    );

                    foreach ($keys4 as $key4) {
												$wert4 = $row4[$key4];
                        $Cdata = $document->createCDATASection($wert4);                   
												$child = $document->createElement($key4);
												$child->appendChild($Cdata);
												$orders_products_attributes->appendChild($child);
                        
                    }
                }

                // exportierte Daten als 'exportiert' kennzeichnen
                //$sql="UPDATE orders SET orders_status=2 WHERE orders_id='$orders_id'";
                //$result3 = mysql_query($sql);
            }
            
            	$sql = "select pa.orders_id, pb.orders_products_id, pb.properties_name as products_options, pb.values_name as products_options_values, p.products_model from orders_products_properties as pb JOIN orders_products as pa  ON pb.orders_products_id = pa.orders_products_id JOIN products as p on p.products_id = pa.products_id WHERE pa.orders_id = '". $db->real_escape_string($nummer) . "' and pb.properties_name <> '' and pb.values_name <> ''";
                $result = $db->query($sql);   
                while ($row4 = $result->fetch_assoc()) {
                    $keys4 = array_keys($row4);
                    $orders_products_attributes = $xtc->appendChild(
                            $document->createElement("ORDERS_PROPERTIES")
                    );

                    foreach ($keys4 as $key4) {
												$wert4 = $row4[$key4];
                        $Cdata = $document->createCDATASection($wert4);                   
												$child = $document->createElement($key4);
												$child->appendChild($Cdata);
												$orders_products_attributes->appendChild($child);
                        
                    }
                }

            $Ergebnis = $document->savexml();          

            $view->init('0', '', '', $Ergebnis, $nummer, __FUNCTION__, '');
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Abrufen der Bestellung.', $e->__toString(), '', $nummer, __FUNCTION__, '');
            return $view;
        }
    }

    function processCategories(RestServer $rest) {
		$this->WriteLine (">-- processCategories");
		$view = new XMLView();
		try {
			$xmlDocoriginal = $rest->getRequest()->getBody();
			$db = $rest->getParameter("db");
			$this->WriteLine ($xmlDocoriginal);
			$xmlDoc = new DomDocument();
				if (!($xmlDoc->loadXML($xmlDocoriginal))) {
					$view->init('1', 'Keine XML Daten', '', '', $xml, __FUNCTION__, '');
					return $view;
				}
			$Categorie = $xmlDoc->getElementsByTagName("Category")->item(0);
			
			$ParentID = "0";

		$categories_permission_status = "0";
			
        foreach ($Categorie->childNodes as $child2) {
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "MainLanguageID") {
                $MainLanguageID = trim($child2->nodeValue);
            }
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "MainLanguageName") {
                $MainLanguageName = trim($child2->nodeValue);
            }
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "categories_image") {
                $categories_image = trim($child2->nodeValue);
            }
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "Sort_Order") {
                $sort_order = trim($child2->nodeValue);
            }
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "products_sort") {
                $products_sort = trim($child2->nodeValue);
            }
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "products_sort2") {
                $products_sort2 = trim($child2->nodeValue);
            }
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "Bild") {
                $bild = trim($child2->nodeValue);
            }
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "status") {
                $status = trim($child2->nodeValue);
            }
			if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "ID") {
				$guid = trim($child2->nodeValue);
			}
			if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "categories_id") {
				$categories_id = trim($child2->nodeValue);
			}
			if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "ShopID") {
				$shopID = trim($child2->nodeValue);
			}
			if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "view_mode_tiled") {
				$viewmode = trim($child2->nodeValue);
			}
			if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "show_sub_products") {
				$sub = trim($child2->nodeValue);
			}
			if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "ParentShopID") {
				$ParentID = trim($child2->nodeValue);
			}
			if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "categories_permission_status") {
				$categories_permission_status = $db->real_escape_string($child2->nodeValue);
				continue;
            }				
        }

			$categories_permissions = $xmlDoc->getElementsByTagName("categories_permissions")->item(0);
		
        switch ($products_sort) {
            case 'Preis':
                $products_sort_translation = "p.products_price";
                break;
            case 'Artikelname':
                $products_sort_translation = "pd.products_name";
                break;
            case 'Sortierreihenfolge':
                $products_sort_translation = "p.products_sort";
                break;
            case 'Gewicht':
                $products_sort_translation = "p.products_weight";
                break;
            case 'Einstelldatum':
                $products_sort_translation = "p.products_date_added";
                break;
            case 'Lagerbestand':
                $products_sort_translation = "p.products_quantity";
                break;
            case 'Artikelnummer':
                $products_sort_translation = "p.products_model";
                break;

            default:
                $products_sort_translation = "";
                break;
        }

        switch ($products_sort2) {
            case 'absteigend':
                $products_sort2_translation = "DESC";
                break;
            case 'aufsteigend':
                $products_sort2_translation = "ASC";
                break;

            default:
                $products_sort2_translation = "";
                break;
        }

		$category_exists = false;
		
		if ($shopID != "")
		{
			$sql = "SELECT categories_id FROM categories WHERE categories_id = '".$shopID."' ";

			if ( $result = $db->query($sql) )
			{
				while ( $obj = mysqli_fetch_object($result) )
				{
					$category_exists = true;
				}
			}		
		}
		
        if (!$shopID || $shopID == "" || $category_exists == false) {
            //nicht vorhanden
            $shopID= $this->CreateCategorie($MainLanguageID, $MainLanguageName, $ParentID, $db, $categories_image, $sort_order, $products_sort_translation, $products_sort2_translation, $bild, $shopID, $status, $sub, $viewmode, $categories_permission_status, $categories_permissions);
        } else {
            $this->UpdateCategorie($MainLanguageID, $MainLanguageName, $ParentID, $db, $categories_image, $sort_order, $products_sort_translation, $products_sort2_translation, $bild, $shopID, $status, $sub, $viewmode, $categories_permission_status, $categories_permissions);
        }

			$descriptions = $Categorie->getElementsByTagName("CategoryDescription");

        foreach ($descriptions as $Description) {
            $this->CreateCategorieDescription($Description, $shopID, $db);
        }

			$view->init('0', 'Kategorie erfolgreich angelegt.', '', '',  $guid . "::" . $shopID, __FUNCTION__, '');
			return $view;
		} catch (Exception $e) {
            $view->init('1', 'Der Kategoriebaum konnte nicht angelegt werden.', $e, '', $rest->getRequest()->getBody(), __FUNCTION__, '');
            return $view;
        }
    }

    private function CreateCategorie($MainLanguageID, $MainLanguageName, $ParentID, $db, $categories_image, $sort_order, $products_sort_translation, $products_sort2_translation, $bild, $shopID, $status, $sub, $viewmode, $categories_permission_status, $categories_permissions) {
		$this->WriteLine (">-- CreateCategorie");
		$this->WriteLine ($categories_permission_status);	
        $sql = "SELECT c.categories_id FROM categories AS c JOIN categories_description AS cd ON c.categories_id = cd.categories_id WHERE c.parent_id = ? AND cd.categories_name = ? AND cd.language_id = ?";
		$stmt = $db->prepare($sql);
		$stmt->bind_param('sss', $ParentID, $MainLanguageName, $MainLanguageID);
		$stmt->execute();
		$stmt->bind_result($cat_id);
        $stmt->fetch();
        $stmt->close();
		
		if ($cat_id)	{
			return $cat_id;
		}
		
		$permission_module_activated = false;
		
		$sql = "SELECT COUNT(COLUMN_NAME) AS PERM_MOD_ACTIVE FROM INFORMATION_SCHEMA.Columns Where TABLE_SCHEMA='".DB_DATABASE."' AND TABLE_NAME='categories' AND COLUMN_NAME LIKE 'group_permission_%'";
		if ( $result = $db->query($sql) )
		{
			while ( $obj = mysqli_fetch_object($result) )
			{
				if ($obj->PERM_MOD_ACTIVE > 0)
					$permission_module_activated = true;
			}
		}
		
		$customers_groups = array();
		
        // Kundengruppen holen
        $sql = "SELECT customers_status_id FROM customers_status group by customers_status_id;";
        $result = $db->query($sql);
        $i = 0;
        while ($obj = $result->fetch_object()) {
            $customers_groups[$i] = $obj->customers_status_id;
            $i++;
        }


        $query = "INSERT INTO categories SET ";
        $query .= "parent_id='" . $db->real_escape_string($ParentID) . "',";
        $query .= "categories_status='" . $db->real_escape_string($status) . "',";
        $query .= "categories_template='categorie_listing.html',";
        $query .= "listing_template='product_listing_v1.html',";
        $query .= "sort_order='" . $db->real_escape_string($sort_order) . "',";
        $query .= "categories_image='" . $db->real_escape_string($bild) . "',";
        $query .= "gm_show_qty_info='" . $db->real_escape_string($gm_show_qty_info) . "',";
        $query .= "show_sub_products='" . $db->real_escape_string($sub) . "',";
        $query .= "view_mode_tiled='" . $db->real_escape_string($viewmode) . "',";
		$query .= "show_sub_categories='1',";
        if ($products_sort_translation <> "") {
            $query .= "products_sorting ='" . $products_sort_translation . "',";
        } else {
            $query .= " products_sorting = 'p.products_model', ";
        }
        if ($products_sort2_translation <> "") {
            $query .= "products_sorting2 ='" . $products_sort2_translation . "',";
        } else {
            $query .= "products_sorting2='ASC',";
        }

        $query .= "date_added=NOW(),";
        $query .= "last_modified=NULL";
		
		//Artikel für Kundengruppen anzeigen
		if ($permission_module_activated)
		{
			if ($categories_permission_status == "0")
			{
				foreach ($customers_groups as $customer_group)
				{
					$query .= ", group_permission_" . $customer_group . "='1' ";
				}
			}
			else
			{
				foreach ($customers_groups as $customer_group)
				{
					$query .= ", group_permission_" . $customer_group . "='0' ";
				}
			}		
		}
		
		if ($shopID != "")
			$query .= ", categories_id='" . $shopID . "' ";
		
        $result = $db->query($query);

        $categories_id = $db->insert_id;

		//Permissions setzen
		$querypart = "";
		
		if ($permission_module_activated)
		{
			foreach ($categories_permissions->childNodes as $child2)
			{
				if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "permission_customer_group")
				{
					$querypart .= "group_permission_". $db->real_escape_string($child2->nodeValue). " = '1',";
				}
			}
			
			if (strlen($querypart) > 0)
			{
				$querypart = substr($querypart, 0, strlen($querypart) - 1);
					
				$sql = "UPDATE categories SET " . $querypart . " WHERE categories_id = '" . $db->real_escape_string($categories_id) . "';";
				$this->WriteLine ($sql);
				$db->query($sql);
			}
		}
		
        //Werte für Kategoriebescheibung
        $query = "INSERT INTO categories_description SET ";
        $query .= " language_id= '" . $MainLanguageID . "', ";
        $query .= " gm_alt_text= '" . $db->real_escape_string("") . "', ";
        $query .= " categories_name='" . $db->real_escape_string($MainLanguageName) . "', ";
        $query .= " categories_id='" . $db->real_escape_string($categories_id) . "'";
        $result = $db->query($query);

        return $categories_id;
    }

    private function GetProductsVPEID($products_vpe_value, $db) {
        if (empty($products_vpe_value)) {
            return 0;
        }

        $sql = "SELECT products_vpe_id FROM products_vpe WHERE products_vpe_name = ? and language_id = 2";
        $stmt = $db->prepare($sql);
        $stmt->bind_param('s', $products_vpe_value);
        $stmt->execute();
        $stmt->bind_result($products_vpe_id);
        $stmt->fetch();
        $stmt->close();


        if ($products_vpe_id) {
            return $products_vpe_id;
        } else {
            //hier neu anlegen

            $sql = "SELECT products_vpe_id FROM products_vpe order by products_vpe_id desc limit 0,1";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $stmt->bind_result($products_vpe_id);
            $stmt->fetch();
            $stmt->close();


            if ($products_vpe_id) {
                if (is_numeric($products_vpe_id)) {
                    $products_vpe_id = $products_vpe_id + 1;
                } else {
                    $products_vpe_id = 0;
                }
            } else {
                $products_vpe_id = 0 + 1;
            }

            if ($products_vpe_id == 0) {
                var_dump("GetProductsVPEID ENDE 0:1");
                return 0;
            }

            $query1 = "insert into products_vpe (products_vpe_id, language_id, products_vpe_name) values ($products_vpe_id, 2, '" . $products_vpe_value . "');";
            $query2 = "insert into products_vpe (products_vpe_id, language_id, products_vpe_name) values ($products_vpe_id, 1, '" . $products_vpe_value . "');";

            if ($db->query($query1) && $db->query($query2)) {
                return $products_vpe_id;
            } else {
                return 0;
            }
        }
    }

    private function UpdateCategorie($MainLanguageID, $MainLanguageName, $ParentID, $db, $categories_image, $sort_order, $products_sort_translation, $products_sort2_translation, $bild, $categories_id, $status, $sub, $viewmode, $categories_permission_status, $categories_permissions) {
		$this->WriteLine (">-- UpdateCategorie");
		$this->WriteLine ($categories_permission_status);
		
		$permission_module_activated = false;
		
		$sql = "SELECT COUNT(COLUMN_NAME) AS PERM_MOD_ACTIVE FROM INFORMATION_SCHEMA.Columns Where TABLE_SCHEMA='".DB_DATABASE."' AND TABLE_NAME='categories' AND COLUMN_NAME LIKE 'group_permission_%'";
		if ( $result = $db->query($sql) )
		{
			while ( $obj = mysqli_fetch_object($result) )
			{
				if ($obj->PERM_MOD_ACTIVE > 0)
					$permission_module_activated = true;
			}
		}

		$customers_groups = array();
		
        // Kundengruppen holen
        $sql = "SELECT customers_status_id FROM customers_status group by customers_status_id;";
        $result = $db->query($sql);
        $i = 0;
        while ($obj = $result->fetch_object()) {
            $customers_groups[$i] = $obj->customers_status_id;
            $i++;
        }
	
		$query = "update categories SET ";
        $query .= "categories_status='" . $db->real_escape_string($status) . "',";
		$query .= "parent_id='" . $db->real_escape_string($ParentID) . "',";
        //$query .= "categories_template='categorie_listing.html',";
        //$query .= "listing_template='product_listing_v1.html',";
        $query .= "categories_image='" . $db->real_escape_string($bild) . "',";
        $query .= "sort_order='" . $db->real_escape_string($sort_order) . "',";
        $query .= "show_sub_products='" . $db->real_escape_string($sub) . "',";
        $query .= "view_mode_tiled='" . $db->real_escape_string($viewmode) . "',";
		$query .= "show_sub_categories='1',";
        if ($products_sort_translation <> "") {
            $query .= "products_sorting ='" . $products_sort_translation . "',";
        } else {
            $query .= " products_sorting = 'p.products_model', ";
        }
        if ($products_sort2_translation <> "") {
            $query .= "products_sorting2 ='" . $products_sort2_translation . "',";
        } else {
            $query .= "products_sorting2='ASC',";
        }

		if ($permission_module_activated)
		{
			if ($categories_permission_status == "0")
			{
				foreach ($customers_groups as $customer_group)
				{
					$query .= "group_permission_" . $customer_group . "='1', ";
				}
			}
			else
			{
				foreach ($customers_groups as $customer_group)
				{
					$query .= "group_permission_" . $customer_group . "='0', ";
				}
			}
		}
		
        $query .= "date_added=NOW(),";
        $query .= "last_modified=NULL";
        $query .= " where categories_id = '" . $categories_id . "' ";
		$this->WriteLine ($query);
        $result = $db->query($query);
		
		//Permissions setzen
		$querypart = "";
		
		if ($permission_module_activated)
		{		
			foreach ($categories_permissions->childNodes as $child2)
			{
				if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "permission_customer_group")
				{
					$querypart .= "group_permission_". $db->real_escape_string($child2->nodeValue). " = '1',";
				}
			}

			if (strlen($querypart) > 0)
			{
				$querypart = substr($querypart, 0, strlen($querypart) - 1);
					
				$sql = "UPDATE categories SET " . $querypart . " WHERE categories_id = '" . $db->real_escape_string($categories_id) . "';";
				$this->WriteLine ($sql);
				$db->query($sql);
			}
		}
    }

    private function CreateCategorieDescription($Description, $ExistingCategorieID, $db) {
        foreach ($Description->childNodes as $child2) {
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "categories_name") {
                $categories_name = trim($child2->nodeValue);
            }
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "categories_description") {
                $categories_description = trim($child2->nodeValue);

            }
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "categories_meta_keywords") {
                $categories_meta_keywords = trim($child2->nodeValue);
            }
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "categories_heading_title") {
                $categories_heading_title = trim($child2->nodeValue);
            }
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "categories_meta_title") {
                $categories_meta_title = trim($child2->nodeValue);
            }
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "categories_meta_description") {
                $categories_meta_description = trim($child2->nodeValue);
            }
            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "language_id") {
                $language_id = trim($child2->nodeValue);
            }
        }


        $query = "SELECT categories_id FROM categories_description WHERE categories_id = '" . $db->real_escape_string($ExistingCategorieID) . "' and language_id = '" . $language_id . "' ";
        $catdesid = $db->query($query)->fetch_object()->categories_id;



        if ($catdesid) {
            $query = "UPDATE categories_description SET ";
            $query .= " categories_name='" . $db->real_escape_string($categories_name) . "', ";
            $query .= " categories_heading_title='" . $db->real_escape_string($categories_heading_title) . "', ";
            $query .= " categories_description='" . $db->real_escape_string($categories_description) . "', ";
            $query .= " categories_meta_title='" . $db->real_escape_string($categories_meta_title) . "', ";
            $query .= " categories_meta_description='" . $db->real_escape_string($categories_meta_description) . "', ";
            $query .= " gm_alt_text= '', ";
            $query .= " categories_meta_keywords='" . $db->real_escape_string($categories_meta_keywords) . "' ";
            $query .= " where categories_id='" . $db->real_escape_string($ExistingCategorieID) . "' and language_id = '" . $language_id . "'";
            $result = $db->query($query);
        } else {
            $query = "INSERT INTO categories_description SET ";
            $query .= " language_id= '" . $language_id . "', ";
            $query .= " categories_name='" . $db->real_escape_string($categories_name) . "', ";
            $query .= " categories_heading_title='" . $db->real_escape_string($categories_heading_title) . "', ";
            $query .= " categories_description='" . $db->real_escape_string($categories_description) . "', ";
            $query .= " categories_meta_title='" . $db->real_escape_string($categories_meta_title) . "', ";
            $query .= " categories_meta_description='" . $db->real_escape_string($categories_meta_description) . "', ";
            $query .= " gm_alt_text= '', ";
            $query .= " categories_meta_keywords='" . $db->real_escape_string($categories_meta_keywords) . "', ";
            $query .= " categories_id='" . $db->real_escape_string($ExistingCategorieID) . "'";
            $result = $db->query($query);
        }
    }

    function returnXsell(RestServer $rest) {
        $view = new XMLView();
        try {
            $db = $rest->getParameter("db");

            $sql = "SELECT products_model FROM products where products_id in (select products_id from products_xsell)";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $stmt->bind_result($products_model);
            $result = "";
            while ($stmt->fetch()) {
                $result .= $products_model . ";";
            }
            $result = substr($result, 0, strlen($result) - 1);
            $view->init('0', '', '', $result, '', __FUNCTION__, $sql);
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Holen der XSELL Artikel', $e->__toString(), '', $result, __FUNCTION__, $sql);
            return $view;
        }
    }

    function CreateXSell(RestServer $rest) {
        $view = new XMLView();
        try {
            $xml = $rest->getRequest()->getBody();
            $db = $rest->getParameter("db");

            $xmlDoc = new DomDocument();
            if (!($xmlDoc->loadXML($xml))) {
                $view->init('1', 'Keine XML Daten', '', '', $xml, __FUNCTION__, '');
                return $view;
            }
            $parent_id = "";

            $xsellproducts = $xmlDoc->getElementsByTagName("XSell");
            foreach ($xsellproducts as $xsellproduct) {

                //produktid filtern
                foreach ($xsellproduct->childNodes as $child) {
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "products_model_parent") {
                        $parent_product = trim($child->nodeValue);
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "products_model_xsell") {
                        $xsell_product = trim($child->nodeValue);
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "sort_order") {
                        $sort_order = trim($child->nodeValue);
                    }
                }
                // parent suchen
                $sql = "SELECT products_id FROM products WHERE products_model = '" . $db->real_escape_string($parent_product) . "';";
                $parent_id = $db->query($sql)->fetch_object()->products_id;
                print($sql);


                $query = "delete from products_xsell ";
                $query .= " where products_id = '" . $db->real_escape_string($parent_id) . "' ";
                $result = $db->query($query);
                break;
            }
            foreach ($xsellproducts as $xsellproduct) {

                //produktid filtern
                foreach ($xsellproduct->childNodes as $child) {
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "products_model_parent") {
                        $parent_product = trim($child->nodeValue);
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "products_model_xsell") {
                        $xsell_product = trim($child->nodeValue);
                    }
                    if ($child->nodeType == XML_ELEMENT_NODE && $child->nodeName == "sort_order") {
                        $sort_order = trim($child->nodeValue);
                    }
                }

                // xsell suchen
                $sql = "SELECT products_id FROM products WHERE products_model = '" . $db->real_escape_string($xsell_product) . "';";
                $xsell_id = $db->query($sql)->fetch_object()->products_id;
                print($sql);

                $xsellgroups = $xsellproduct->getElementsByTagname("XSellGroups");

                foreach ($xsellgroups as $xsellgroup) {
                    foreach ($xsellgroup->childNodes as $child2) {
                        if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "language_id") {
                            if (trim($child2->nodeValue) == '2') {
                                foreach ($xsellgroup->childNodes as $child3) {
                                    if ($child3->nodeName == "group_name") {
                                        $german_group = $child3->nodeValue;
                                    }
                                }
                            }
                        }
                    }
                }

                if ($german_group != "") {
                    $sql = "SELECT products_xsell_grp_name_id FROM products_xsell_grp_name WHERE groupname = '" . $db->real_escape_string($german_group) . "' and language_id = '2' ;";
                    $german_group_id = $db->query($sql)->fetch_object()->products_xsell_grp_name_id;
                    if (!$german_group_id) {
                        $query = "INSERT INTO products_xsell_grp_names SET ";
                        $query .= " language_id= '2', ";
                        $query .= " groupname='" . $db->real_escape_string($german_group) . "', ";
                        $result = $db->query($query);
                        $sql = "SELECT products_xsell_grp_name_id FROM products_xsell_grp_name WHERE groupname = '" . $db->real_escape_string($german_group) . "';";
                        $german_group_id = $db->query($sql)->fetch_object()->products_xsell_grp_name_id;
                    }
                    foreach ($xsellgroups as $xsellgroup) {
                        $group_name = "";
                        $gid = "";
                        foreach ($xsellgroup->childNodes as $child2) {
                            if ($child2->nodeType == XML_ELEMENT_NODE && $child2->nodeName == "language_id") {
                                if (trim($child->nodeValue) != '2') {
                                    foreach ($xsellgroup->childNodes as $child3) {
                                        if ($child3->nodeName == "group_name") {
                                            $group_name = $child3->nodeValue;
                                        }
                                        if ($child3->nodeName == "language_id") {
                                            $language_id = $child3->nodeValue;
                                        }
                                        if ($child3->nodeName == "group_id") {
                                            $gid = $child3->nodeValue;
                                        }
                                    }
                                }
                            }
                        }

                        $sql = "SELECT products_xsell_grp_name_id FROM products_xsell_grp_name WHERE products_xsell_grp_name_id = '" . $db->real_escape_string($gid) . "' and language_id = '" . $db->real_escape_string($language_id) . "' ;";
                        $group_id = $db->query($sql)->fetch_object()->products_xsell_grp_name_id;
                        if ($group_id == NULL) {
                            $query = "INSERT INTO products_xsell_grp_name SET ";
                            $query .= " language_id= '" . $db->real_escape_string($language_id) . "', ";
                            $query .= " groupname='" . $db->real_escape_string($group_name) . "', ";
                            $query .= " products_xsell_grp_name_id='" . $db->real_escape_string($gid) . "' ";
                            $result = $db->query($query);
                        } elseif ($group_id >= 0) {
                            $query = "update products_xsell_grp_name SET ";
                            $query .= " groupname='" . $db->real_escape_string($group_name) . "' WHERE products_xsell_grp_name_id = '" . $db->real_escape_string($gid) . "' and language_id = '" . $db->real_escape_string($language_id) . "' ; ";
                            $result = $db->query($query);
                        }
                    }
                }

                if (!$german_group_id) {
                    $german_group_id = '';
                }
                $sql = "SELECT id FROM products_xsell WHERE products_id = '" . $db->real_escape_string($parent_id) . "' and xsell_id = '" . $db->real_escape_string($xsell_id) . "' ;";
                $xsellentry = $db->query($sql)->fetch_object()->id;
                if (!$xsellentry) {
                    $query = "INSERT INTO products_xsell SET ";
                    $query .= " products_id = '" . $db->real_escape_string($parent_id) . "', ";
                    $query .= " sort_order = '" . $db->real_escape_string($sort_order) . "', ";
					$query .= " products_xsell_grp_name_id = '" . $db->real_escape_string($gid) . "',";
                    $query .= " xsell_id ='" . $db->real_escape_string($xsell_id) . "' ";
                    $result = $db->query($query);
                    print($query);
                } else {
                    $query = "update products_xsell SET ";
                    $query .= " sort_order = '" . $db->real_escape_string($sort_order) . "' ";
					$query .= " products_xsell_grp_name_id = '" . $db->real_escape_string($gid) . "',";
                    $query .= " where products_id = '" . $db->real_escape_string($parent_id) . "' ";
                    $query .= " and xsell_id ='" . $db->real_escape_string($xsell_id) . "' ";
                    $result = $db->query($query);
                    print($query);
                }
            }
            $view->init('0', '', '', 'OK', $xml, __FUNCTION__, $queries);
			return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Anlegen des Artikels.', $e->__toString(), '', $xml, __FUNCTION__, $queries);
            return $view;
        }
    }

	function DeleteXSell(RestServer $rest) {
		$view = new XMLView();
        try {
            $db = $rest->getParameter("db");
			$master = $rest->getRequest()->getBody();

			if (!$master) {
				$view->init('1', 'Fehler beim Löschen der XSell Artikel. Die Master-Artikelnummer konnte nicht gelesen werden.', '', '', $result, __FUNCTION__, $sql);
				return $view;
			}
			
            $sql = "DELETE FROM products_xsell WHERE products_id = (SELECT products_id FROM products WHERE products_model = ?)";
            $stmt = $db->prepare($sql);
			$stmt->bind_param('s', $master);
            if ($stmt->execute()) 
				$view->init('0', 'XSell Artikel gelöscht', '', '', '', __FUNCTION__, $sql);
			else
				$view->init('0', 'XSell Artikel wurden nicht gelöscht', '', '', '', __FUNCTION__, $sql);
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Löschen der XSell Artikel', $e->__toString(), '', '', __FUNCTION__, $sql);
            return $view;
        }
	}


    function userFunction(RestServer $rest) {
        $view = new XMLView();
        try {
            $function = $rest->getRequest()->getUri(2);

            if (function_exists($function)) {
                return call_user_func($function, $rest, $this);
            } else {
                $view->init('2', 'Userfunction ' . $function . ' existiert nicht.', '', '', $function, __FUNCTION__, '');
                return $view;
            }
        } catch (Exception $e) {
            $view->init('2', 'Fehler beim Ausführen der USERFUNCTION', $e->__toString(), '', $function, __FUNCTION__, '');
            return $view;
        }
    }

    private function GetUnit($products_unit_description, $products_id, $db) {
        $sql = "SELECT quantity_unit_id FROM quantity_unit_description WHERE unit_name = ? and language_id = 2";
        $stmt = $db->prepare($sql);
        $stmt->bind_param('s', $products_unit_description);
        $stmt->execute();
        $stmt->bind_result($products_unit_id);
        $stmt->fetch();
        $stmt->close();

        if ($products_unit_id) {
            $query1 = "DELETE FROM products_quantity_unit WHERE products_id = '" . $products_id . "'";
            $query2 = "INSERT INTO products_quantity_unit (products_id, quantity_unit_id) VALUES (" . $products_id . "," . $products_unit_id . ")";

            if ($db->query($query1) && $db->query($query2)) {
                return "successs";
            } else {
                return "error";
            }
        } else {
            $sql = "SELECT MAX(quantity_unit_id) FROM quantity_unit";
            $stmt = $db->prepare($sql);
            $stmt->execute();
            $stmt->bind_result($highest_id);
            $stmt->fetch();
            $stmt->close();
            $highest_id = $highest_id + 1;

            $query1 = "DELETE FROM products_quantity_unit WHERE products_id = '" . $products_id . "'";
            $query2 = "INSERT INTO quantity_unit (quantity_unit_id) VALUES (" . $highest_id . ")";
            $query3 = "INSERT INTO quantity_unit_description (quantity_unit_id,unit_name, language_id) VALUES (" . $highest_id . ",'" . $products_unit_description . "',2)";
            $query4 = "INSERT INTO products_quantity_unit (products_id, quantity_unit_id) VALUES (" . $products_id . "," . $highest_id . ")";


            if ($db->query($query1) && $db->query($query2) && $db->query($query3) && $db->query($query4)) {
                return "success";
            } else {
                return "error";
            }
        }
    }

	function updateProductsQuantities(RestServer $rest) 
	{
		$view = new XMLView();
		try {
			$db = $rest->getParameter("db");
			$valueString = $rest->getRequest()->getBody();
			
			$queries = "";
			$success = false;
			if (strlen($valueString) > 0) {
				if (strpos($valueString, '::') != false) {				
					if (strpos($valueString, '|') != false) {
						$valuePairs = explode('|', $valueString);
						foreach ($valuePairs as $pair) {
							$valueArray = explode('::', $pair);
							if ($valueArray[0] == "product") {
								$queries .= "UPDATE products SET products_quantity = " . $db->real_escape_string($valueArray[2]) . " WHERE products_model = '" . $db->real_escape_string($valueArray[1]) . "';";
							}
							elseif ($valueArray[0] == "property") {
								$queries .= "UPDATE products_properties_combis SET combi_quantity = " . $db->real_escape_string($valueArray[2]) . " WHERE combi_model = '" . $db->real_escape_string($valueArray[1]) . "';";
							}
						}					
						if ($db->multi_query($queries)) {
							while ($db->next_result()) {
								;
							}
							$success = true;
						}
											
    }
					else {
						$valueArray = explode('::', $valueString);
						if ($valueArray[0] == "product") {
							$queries = "UPDATE products SET products_quantity = " . $db->real_escape_string($valueArray[2]) . " WHERE products_model = '" . $db->real_escape_string($valueArray[1]) . "';";
						}
						elseif ($valueArray[0] == "property") {
							$queries = "UPDATE products_properties_combis SET combi_quantity = " . $db->real_escape_string($valueArray[2]) . " WHERE combi_model = '" . $db->real_escape_string($valueArray[1]) . "';";
						}
						
						if ($db->query($queries)) {
							$success = true;
						}
					}
					
					if ($success) {
						$view->init('0', '', '', '', '', __FUNCTION__, '');
					}
					else {
						$view->init('1', 'SQL Befehl nicht ausgeführt', '', '', '', __FUNCTION__, '');
					}	
					return $view;					
				}
				else {
					$view->init('1', 'Der übergebene Wert hatte nicht das korrekte Format.', '', '', '', __FUNCTION__, '');
				}
			}
			else {
				$view->init('1', 'Die übergebene Liste war leer.', '', '', '', __FUNCTION__, '');
			}
		} catch (Exception $e) {
			$view->init('1', 'Fehler beim Ausführen von updateProductsQuantities', $e->__toString(), '', '', __FUNCTION__, '');
			return $view;
		}
	}


   function getTaxRates(RestServer $rest) {
        $view = new XMLView();
        try {
            $document = new DOMDocument('1.0', "utf-8");
            $document->formatOutput = TRUE;
            $document->standalone = true;

            $xtc = $document->appendChild(
                    $document->createElement("XTC")
            );
        
            $db = $rest->getParameter("db");
            $tax_id = $rest->getRequest()->getUri(2);
            
            $sql = "SELECT tax_rates_id AS ShopID , Tax_zone_id as CountryID, tax_class_id,tax_rate, tax_description as Description, 1 as active FROM `tax_rates`";
     
            $result = $db->query($sql);    
            
            if ($db->affected_rows == 0) {
                $view->init('1', 'Keine SQL-Ergebnismenge.', '', '', $tax_id, __FUNCTION__, $sql);
                return $view;
            }
            
            while ($row = $result->fetch_assoc()) {
                $keys = array_keys($row);

               $txr= $xtc->appendChild(
                  $document->createElement("TAX_RATES")
                );
                
                foreach ($keys as $key) {
                    $wert = $row[$key];
                    $Cdata = $document->createCDATASection($wert);                   
                    $child = $document->createElement($key);
                    $child->appendChild($Cdata);
                    $txr->appendChild($child);
                }
            }
            
            $Ergebnis = $document->savexml();          

            $view->init('0', '', '', $Ergebnis, $tax_id, __FUNCTION__, '');
            return $view;
        } catch (Exception $e) {
            $view->init('1', 'Fehler beim Holen der Tax Rates', $e->__toString(), '', $result, __FUNCTION__, $sql);
            return $view;
        }
    }

	/**
	* Dummy implementation.
	*/
	function rebuildCategoriesNestedSet(RestServer $rest) 
	{
		$view = new XMLView();
		$view->init('0', 'Nicht unterstützt.', '', '', '', __FUNCTION__, '');
		return $view;
	}
    
    
}

?>
